searchData={"items":[{"type":"module","title":"IbkrApi.AssetClass","doc":"Asset class module for IBKR Client Portal API.","ref":"IbkrApi.AssetClass.html"},{"type":"function","title":"IbkrApi.AssetClass.bond/0","doc":"","ref":"IbkrApi.AssetClass.html#bond/0"},{"type":"function","title":"IbkrApi.AssetClass.contract_for_difference/0","doc":"","ref":"IbkrApi.AssetClass.html#contract_for_difference/0"},{"type":"function","title":"IbkrApi.AssetClass.forex/0","doc":"","ref":"IbkrApi.AssetClass.html#forex/0"},{"type":"function","title":"IbkrApi.AssetClass.future/0","doc":"","ref":"IbkrApi.AssetClass.html#future/0"},{"type":"function","title":"IbkrApi.AssetClass.inter_commodity_spread/0","doc":"","ref":"IbkrApi.AssetClass.html#inter_commodity_spread/0"},{"type":"function","title":"IbkrApi.AssetClass.mutual_fund/0","doc":"","ref":"IbkrApi.AssetClass.html#mutual_fund/0"},{"type":"function","title":"IbkrApi.AssetClass.option/0","doc":"","ref":"IbkrApi.AssetClass.html#option/0"},{"type":"function","title":"IbkrApi.AssetClass.stock/0","doc":"","ref":"IbkrApi.AssetClass.html#stock/0"},{"type":"function","title":"IbkrApi.AssetClass.warrent/0","doc":"","ref":"IbkrApi.AssetClass.html#warrent/0"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.EndSessionResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.EndSessionResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.IServer","doc":"","ref":"IbkrApi.ClientPortal.Auth.IServer.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.PingServerResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.PingServerResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.ReauthenticateResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.ReauthenticateResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.ServerInfo","doc":"","ref":"IbkrApi.ClientPortal.Auth.ServerInfo.html"},{"type":"module","title":"IbkrApi.ClientPortal.Auth.ValidateSSOResponse","doc":"","ref":"IbkrApi.ClientPortal.Auth.ValidateSSOResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Contract","doc":"Contract information within stock security definition","ref":"IbkrApi.ClientPortal.Contract.Contract.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractDetails","doc":"","ref":"IbkrApi.ClientPortal.Contract.ContractDetails.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractId","doc":"Contract ID information","ref":"IbkrApi.ClientPortal.Contract.ContractId.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractIssuer","doc":"Bond issuer information","ref":"IbkrApi.ClientPortal.Contract.ContractIssuer.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.ContractSection","doc":"Contract section information within search results","ref":"IbkrApi.ClientPortal.Contract.ContractSection.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.CurrencyPair","doc":"Available currency pair information","ref":"IbkrApi.ClientPortal.Contract.CurrencyPair.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Schedule","doc":"Daily trading schedule information","ref":"IbkrApi.ClientPortal.Contract.Schedule.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SearchContract","doc":"Contract search result","ref":"IbkrApi.ClientPortal.Contract.SearchContract.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Secdef","doc":"Security definition structure","ref":"IbkrApi.ClientPortal.Contract.Secdef.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SecdefInfo","doc":"Detailed contract information from secdef/info endpoint","ref":"IbkrApi.ClientPortal.Contract.SecdefInfo.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SecurityFutures","doc":"","ref":"IbkrApi.ClientPortal.Contract.SecurityFutures.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.SecurityStocks","doc":"","ref":"IbkrApi.ClientPortal.Contract.SecurityStocks.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.Session","doc":"Trading session information","ref":"IbkrApi.ClientPortal.Contract.Session.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.StockSecurityDefinition","doc":"Stock security definition response","ref":"IbkrApi.ClientPortal.Contract.StockSecurityDefinition.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.StrikesResponse","doc":"Response structure for option strikes","ref":"IbkrApi.ClientPortal.Contract.StrikesResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.TradingSchedule","doc":"Complete trading schedule for an exchange","ref":"IbkrApi.ClientPortal.Contract.TradingSchedule.html"},{"type":"module","title":"IbkrApi.ClientPortal.Contract.TradingTime","doc":"Trading time information within a trading schedule","ref":"IbkrApi.ClientPortal.Contract.TradingTime.html"},{"type":"module","title":"IbkrApi.ClientPortal.MarketData","doc":"Market Data functionality for the IBKR Client Portal API.\n\nThis module provides functions to retrieve live market data snapshots and other\nmarket data related information.","ref":"IbkrApi.ClientPortal.MarketData.html"},{"type":"function","title":"IbkrApi.ClientPortal.MarketData.get_historical_data/4","doc":"Retrieves historical market data for a contract.","ref":"IbkrApi.ClientPortal.MarketData.html#get_historical_data/4"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.MarketData.get_historical_data/4","doc":"- `conid`: Contract identifier\n- `period`: Duration of data to fetch (e.g., \"1w\", \"1mo\", \"1d\", \"2h\")\n- `bar`: Bar size (e.g., \"1hour\", \"5min\", \"1day\")\n- `opts`: Optional parameters\n  - `:outside_rth` - Include extended hours? (default: false)\n  - `:exchange` - Optional exchange (default: \"SMART\")","ref":"IbkrApi.ClientPortal.MarketData.html#get_historical_data/4-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.MarketData.get_historical_data/4","doc":"iex> get_historical_data(\"265598\", \"2w\", \"1hour\")\n    {:ok, [%HistoricalBar{timestamp: ~U[2024-02-05 14:00:00Z], open: 189.9, ...}, ...]}\n\n    iex> get_historical_data(\"265598\", \"1d\", \"5min\", outside_rth: true)\n    {:ok, [%HistoricalBar{...}, ...]}","ref":"IbkrApi.ClientPortal.MarketData.html#get_historical_data/4-examples"},{"type":"function","title":"IbkrApi.ClientPortal.MarketData.live_market_data_snapshots/2","doc":"Retrieves live market data snapshots for one or more contracts.\n\nFor derivative contracts, /iserver/secdef/search must be called first.","ref":"IbkrApi.ClientPortal.MarketData.html#live_market_data_snapshots/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.MarketData.live_market_data_snapshots/2","doc":"- `conids`: Contract identifier(s) - can be a single string or comma-separated string\n- `opts`: Optional parameters\n  - `:fields` - List of specific field codes to request (defaults to all fields)","ref":"IbkrApi.ClientPortal.MarketData.html#live_market_data_snapshots/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.MarketData.live_market_data_snapshots/2","doc":"iex> live_market_data_snapshots(\"265598\")\n    {:ok, [%MarketDataSnapshot{symbol: \"AAPL\", last_price: 150.25, ...}]}\n\n    iex> live_market_data_snapshots(\"265598,8314\", fields: [\"31\", \"55\"])\n    {:ok, [%MarketDataSnapshot{last_price: 150.25, symbol: \"AAPL\"}, ...]}","ref":"IbkrApi.ClientPortal.MarketData.html#live_market_data_snapshots/2-examples"},{"type":"module","title":"IbkrApi.ClientPortal.MarketData.HistoricalBar","doc":"Historical market data bar structure.","ref":"IbkrApi.ClientPortal.MarketData.HistoricalBar.html"},{"type":"function","title":"IbkrApi.ClientPortal.MarketData.HistoricalBar.from_ibkr/1","doc":"Converts IBKR API response data to HistoricalBar struct.","ref":"IbkrApi.ClientPortal.MarketData.HistoricalBar.html#from_ibkr/1"},{"type":"type","title":"IbkrApi.ClientPortal.MarketData.HistoricalBar.t/0","doc":"","ref":"IbkrApi.ClientPortal.MarketData.HistoricalBar.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.MarketData.MarketDataSnapshot","doc":"Market data snapshot response structure with descriptive field names.\nAll numeric field codes are mapped to their descriptive equivalents.","ref":"IbkrApi.ClientPortal.MarketData.MarketDataSnapshot.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.CancelOrderResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.CancelOrderResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.LiveOrder","doc":"","ref":"IbkrApi.ClientPortal.Order.LiveOrder.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.ModifyOrderRequest","doc":"Struct representing a request to modify an existing order.","ref":"IbkrApi.ClientPortal.Order.ModifyOrderRequest.html"},{"type":"type","title":"IbkrApi.ClientPortal.Order.ModifyOrderRequest.t/0","doc":"Type representing a modify order request struct.","ref":"IbkrApi.ClientPortal.Order.ModifyOrderRequest.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Order.ModifyOrderResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.ModifyOrderResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderPlacementResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderPlacementResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderPreviewRequest","doc":"Struct representing a request to preview an order before placement.","ref":"IbkrApi.ClientPortal.Order.OrderPreviewRequest.html"},{"type":"type","title":"IbkrApi.ClientPortal.Order.OrderPreviewRequest.t/0","doc":"Type representing an order preview request struct.","ref":"IbkrApi.ClientPortal.Order.OrderPreviewRequest.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderPreviewResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderPreviewResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderReplyResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderReplyResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderRequest","doc":"Struct representing a request to place a new order.","ref":"IbkrApi.ClientPortal.Order.OrderRequest.html"},{"type":"type","title":"IbkrApi.ClientPortal.Order.OrderRequest.t/0","doc":"Type representing an order request struct.","ref":"IbkrApi.ClientPortal.Order.OrderRequest.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Order.OrderStatusResponse","doc":"","ref":"IbkrApi.ClientPortal.Order.OrderStatusResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio","doc":"Portfolio and Account management functions for IBKR Client Portal API.\nHandles account information, positions, allocations, summaries, and ledgers.","ref":"IbkrApi.ClientPortal.Portfolio.html"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_allocation/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_allocation/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_info/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_info/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_ledger/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_ledger/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.account_summary/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#account_summary/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.all_accounts_allocation/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#all_accounts_allocation/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.get_pnl/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#get_pnl/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.invalidate_positions_cache/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#invalidate_positions_cache/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_accounts/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_accounts/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_brokerage_accounts/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_brokerage_accounts/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_large_sub_accounts/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_large_sub_accounts/1"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.list_sub_accounts/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#list_sub_accounts/0"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.portfolio_positions/2","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#portfolio_positions/2"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.position_by_conid/2","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#position_by_conid/2"},{"type":"function","title":"IbkrApi.ClientPortal.Portfolio.switch_account/1","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.html#switch_account/1"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.Account","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.Account.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.AccountAllocation","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.AccountAllocation.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.AccountLedger","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.AccountLedger.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.AccountSummary","doc":"AccountSummary struct containing all account summary fields.\nEach field is a SummaryField struct with timestamp, value, currency, severity, amount, and is_null information.","ref":"IbkrApi.ClientPortal.Portfolio.AccountSummary.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.BrokerageAccountsResponse","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.BrokerageAccountsResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.LargeSubAccounts","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.LargeSubAccounts.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.LedgerCurrency","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.LedgerCurrency.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.PnLAccountData","doc":"Represents PnL data for a specific account.\nContains daily and unrealized PnL information.","ref":"IbkrApi.ClientPortal.Portfolio.PnLAccountData.html"},{"type":"type","title":"IbkrApi.ClientPortal.Portfolio.PnLAccountData.t/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.PnLAccountData.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.PnLResponse","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.PnLResponse.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.PortfolioPosition","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.PortfolioPosition.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SubAccount","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.SubAccount.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SubAccountsMetadata","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.SubAccountsMetadata.html"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SummaryField","doc":"Represents a single field in an account summary response.\nEach field contains metadata about the value including timestamp, currency, and severity.","ref":"IbkrApi.ClientPortal.Portfolio.SummaryField.html"},{"type":"type","title":"IbkrApi.ClientPortal.Portfolio.SummaryField.t/0","doc":"","ref":"IbkrApi.ClientPortal.Portfolio.SummaryField.html#t:t/0"},{"type":"module","title":"IbkrApi.ClientPortal.Portfolio.SwitchAccountResponse","doc":"Response from switching accounts.\nCan contain different fields depending on the response:\n- success: String message when account is already set or successfully switched\n- set: Boolean indicating if account was set (in some responses)\n- acctId: Account ID that was switched to (in some responses)","ref":"IbkrApi.ClientPortal.Portfolio.SwitchAccountResponse.html"},{"type":"module","title":"IbkrApi.MockConfig","doc":"Mock configuration module for testing rate limiting with custom configurations.","ref":"IbkrApi.MockConfig.html"},{"type":"function","title":"IbkrApi.MockConfig.new/1","doc":"","ref":"IbkrApi.MockConfig.html#new/1"},{"type":"function","title":"IbkrApi.MockConfig.rate_limit/2","doc":"","ref":"IbkrApi.MockConfig.html#rate_limit/2"},{"type":"module","title":"IbkrApi.RateLimiter","doc":"Rate limiting implementation for IBKR API requests using Hammer v7.\n\nEnforces both global and per-endpoint rate limits according to IBKR's published limits:\n- Global: 50 requests per second\n- Gateway: 10 requests per second\n- Per-endpoint: Various limits as documented\n\nRate limits are configurable through options passed to each function.","ref":"IbkrApi.RateLimiter.html"},{"type":"function","title":"IbkrApi.RateLimiter.check_endpoint_rate/3","doc":"Checks the endpoint-specific rate limit.\n\nEach endpoint may have its own rate limit as defined in IBKR's documentation.","ref":"IbkrApi.RateLimiter.html#check_endpoint_rate/3"},{"type":"function","title":"IbkrApi.RateLimiter.check_global_rate/1","doc":"Checks the global rate limit for all IBKR API requests.\n\nBy default, this is 50 requests per second for authenticated users.","ref":"IbkrApi.RateLimiter.html#check_global_rate/1"},{"type":"function","title":"IbkrApi.RateLimiter.check_rate/2","doc":"Checks if a request should be allowed based on the rate limits.","ref":"IbkrApi.RateLimiter.html#check_rate/2"},{"type":"function","title":"Options - IbkrApi.RateLimiter.check_rate/2","doc":"* `:rate_limits` (`t:keyword/0`) - Rate limit configuration as a keyword list. If not provided, uses Config defaults.\n\n* `:bucket_prefix` (`t:String.t/0`) - Prefix for rate limit buckets (useful for test isolation) The default value is `\"\"`.","ref":"IbkrApi.RateLimiter.html#check_rate/2-options"},{"type":"function","title":"Returns - IbkrApi.RateLimiter.check_rate/2","doc":"- `:ok` if the request is allowed\n- `{:error, reason}` if the request exceeds rate limits","ref":"IbkrApi.RateLimiter.html#check_rate/2-returns"},{"type":"function","title":"IbkrApi.RateLimiter.extract_endpoint/1","doc":"Extracts the endpoint name from a URL path.\n\nExamples:\n  \"/iserver/marketdata/snapshot\" -> \"iserver_marketdata_snapshot\"\n  \"/iserver/scanner/run\" -> \"iserver_scanner_run\"","ref":"IbkrApi.RateLimiter.html#extract_endpoint/1"},{"type":"function","title":"IbkrApi.RateLimiter.with_rate_limit/3","doc":"Executes a function with rate limiting.\n\nReturns the function result if the rate limit allows the request,\nor `{:error, error_message}` if the rate limit is exceeded.","ref":"IbkrApi.RateLimiter.html#with_rate_limit/3"},{"type":"module","title":"IbkrApi.Support.HTTPMock","doc":"Helper functions for creating mock HTTP responses.\n\nThis module provides functions for creating standard response formats\nfor success responses, error responses, and network errors.","ref":"IbkrApi.Support.HTTPMock.html"},{"type":"function","title":"IbkrApi.Support.HTTPMock.error/3","doc":"Creates an error HTTP response.","ref":"IbkrApi.Support.HTTPMock.html#error/3"},{"type":"function","title":"Parameters - IbkrApi.Support.HTTPMock.error/3","doc":"- `error_body`: The error response body (map)\n- `status`: HTTP status code (default: 400)\n- `headers`: Response headers (default: [])","ref":"IbkrApi.Support.HTTPMock.html#error/3-parameters"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPMock.error/3","doc":"HTTPMock.error(%{\"error\" => \"Invalid request\"}, 400)\n    # Returns: {:error, %Response{status: 400, body: %{\"error\" => \"Invalid request\"}}}","ref":"IbkrApi.Support.HTTPMock.html#error/3-examples"},{"type":"function","title":"IbkrApi.Support.HTTPMock.network_error/1","doc":"Creates a network error response.","ref":"IbkrApi.Support.HTTPMock.html#network_error/1"},{"type":"function","title":"Parameters - IbkrApi.Support.HTTPMock.network_error/1","doc":"- `reason`: The error reason (:timeout, :closed, etc.)","ref":"IbkrApi.Support.HTTPMock.html#network_error/1-parameters"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPMock.network_error/1","doc":"HTTPMock.network_error(:timeout)\n    # Returns: {:error, :timeout}","ref":"IbkrApi.Support.HTTPMock.html#network_error/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPMock.success/3","doc":"Creates a successful HTTP response.","ref":"IbkrApi.Support.HTTPMock.html#success/3"},{"type":"function","title":"Parameters - IbkrApi.Support.HTTPMock.success/3","doc":"- `body`: The response body (map or list)\n- `status`: HTTP status code (default: 200)\n- `headers`: Response headers (default: [])","ref":"IbkrApi.Support.HTTPMock.html#success/3-parameters"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPMock.success/3","doc":"HTTPMock.success(%{\"id\" => 1, \"name\" => \"Item\"})\n    # Returns: {:ok, {%{\"id\" => 1, \"name\" => \"Item\"}, %Response{status: 200}}}","ref":"IbkrApi.Support.HTTPMock.html#success/3-examples"},{"type":"module","title":"IbkrApi.Support.HTTPMockHelper","doc":"Helper module for using HTTP mocks in tests.\n\n**DEPRECATED**: This module is deprecated in favor of using HTTPSandbox and the explicit stub modules.\n\nUse the stub modules directly instead:\n\n```elixir\nalias IbkrApi.Support.HTTPStubs.{AuthStub, TradeStub, ContractStub, MarketDataStub, PortfolioStub, OrderStub}\n\n# Register stubs in your test\ntest \"example test\" do\n  AuthStub.stub_auth_status()\n  TradeStub.stub_list_trades()\n  \n  # Make your assertions\nend\n```\n\nSee the documentation in guides/how-to/testing_with_http_mocks.md for more details.\n\n@deprecated \"Use HTTPSandbox and explicit stub modules instead\"","ref":"IbkrApi.Support.HTTPMockHelper.html"},{"type":"macro","title":"IbkrApi.Support.HTTPMockHelper.__using__/1","doc":"Macro that imports the helper functions for HTTP mocking.","ref":"IbkrApi.Support.HTTPMockHelper.html#__using__/1"},{"type":"function","title":"IbkrApi.Support.HTTPMockHelper.mock_http/3","doc":"Mocks an HTTP function for a specific module.","ref":"IbkrApi.Support.HTTPMockHelper.html#mock_http/3"},{"type":"function","title":"Parameters - IbkrApi.Support.HTTPMockHelper.mock_http/3","doc":"- module_key: The module key (:auth, :trade, :contract, :market_data, :portfolio, :order)\n- function_name: The name of the stub function to use (e.g. :stub_list_trades)\n- custom_response: Optional custom response function","ref":"IbkrApi.Support.HTTPMockHelper.html#mock_http/3-parameters"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPMockHelper.mock_http/3","doc":"mock_http(:trade, :stub_list_trades)\n    mock_http(:auth, :stub_auth_status, my_custom_response_fn)","ref":"IbkrApi.Support.HTTPMockHelper.html#mock_http/3-examples"},{"type":"function","title":"IbkrApi.Support.HTTPMockHelper.reset_http_mocks/0","doc":"Reset all HTTP mocks to their original implementations.\n\n@deprecated \"Use HTTPSandbox.reset() instead\"","ref":"IbkrApi.Support.HTTPMockHelper.html#reset_http_mocks/0"},{"type":"module","title":"IbkrApi.Support.HTTPSandbox","doc":"HTTP sandbox for mocking HTTP requests in tests.\n\nStores response functions in a Registry under the PID of the test process.\nIn test, the IbkrApi.SharedUtils.HTTP module will check this sandbox before\nmaking actual HTTP requests.","ref":"IbkrApi.Support.HTTPSandbox.html"},{"type":"type","title":"IbkrApi.Support.HTTPSandbox.action/0","doc":"","ref":"IbkrApi.Support.HTTPSandbox.html#t:action/0"},{"type":"type","title":"IbkrApi.Support.HTTPSandbox.body/0","doc":"","ref":"IbkrApi.Support.HTTPSandbox.html#t:body/0"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.delete_response/3","doc":"Retrieves the response for a DELETE request","ref":"IbkrApi.Support.HTTPSandbox.html#delete_response/3"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.find!/2","doc":"Finds the appropriate response function for the given action and URL.\nReturns the function or raises an error.","ref":"IbkrApi.Support.HTTPSandbox.html#find!/2"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.get_response/3","doc":"Retrieves the response for a GET request","ref":"IbkrApi.Support.HTTPSandbox.html#get_response/3"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.head_response/3","doc":"Retrieves the response for a HEAD request","ref":"IbkrApi.Support.HTTPSandbox.html#head_response/3"},{"type":"type","title":"IbkrApi.Support.HTTPSandbox.headers/0","doc":"","ref":"IbkrApi.Support.HTTPSandbox.html#t:headers/0"},{"type":"type","title":"IbkrApi.Support.HTTPSandbox.options/0","doc":"","ref":"IbkrApi.Support.HTTPSandbox.html#t:options/0"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.post_response/4","doc":"Retrieves the response for a POST request","ref":"IbkrApi.Support.HTTPSandbox.html#post_response/4"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.put_response/4","doc":"Retrieves the response for a PUT request","ref":"IbkrApi.Support.HTTPSandbox.html#put_response/4"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.sandbox_disabled?/0","doc":"Checks if the HTTP sandbox is disabled.\nUsed by the HTTP client to determine whether to use mock responses.\n\nAlways returns false in tests, meaning the sandbox is always enabled.","ref":"IbkrApi.Support.HTTPSandbox.html#sandbox_disabled?/0"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.set_delete_responses/1","doc":"Sets sandbox responses for DELETE requests.","ref":"IbkrApi.Support.HTTPSandbox.html#set_delete_responses/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPSandbox.set_delete_responses/1","doc":"HTTPSandbox.set_delete_responses([\n      {\"https://localhost:5000/v1/api/iserver/account/order/12345\", fn ->\n        {:ok, %{\"id\" => \"12345\"}, %IbkrApi.SharedUtils.HTTP.Response{status: 200}}\n      end}\n    ])","ref":"IbkrApi.Support.HTTPSandbox.html#set_delete_responses/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.set_get_responses/1","doc":"Sets sandbox responses for GET requests.","ref":"IbkrApi.Support.HTTPSandbox.html#set_get_responses/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPSandbox.set_get_responses/1","doc":"HTTPSandbox.set_get_responses([\n      {\"https://localhost:5000/v1/api/iserver/auth/status\", fn ->\n        {:ok, %{\n          \"authenticated\" => true,\n          \"competing\" => false,\n          \"connected\" => true,\n          \"message\" => \"\"\n        }, %IbkrApi.SharedUtils.HTTP.Response{status: 200}}\n      end}\n    ])","ref":"IbkrApi.Support.HTTPSandbox.html#set_get_responses/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.set_head_responses/1","doc":"Sets sandbox responses for HEAD requests.","ref":"IbkrApi.Support.HTTPSandbox.html#set_head_responses/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPSandbox.set_head_responses/1","doc":"HTTPSandbox.set_head_responses([\n      {\"https://localhost:5000/v1/api/iserver/auth/status\", fn ->\n        {:ok, %{}, %IbkrApi.SharedUtils.HTTP.Response{status: 200}}\n      end}\n    ])","ref":"IbkrApi.Support.HTTPSandbox.html#set_head_responses/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.set_post_responses/1","doc":"Sets sandbox responses for POST requests.","ref":"IbkrApi.Support.HTTPSandbox.html#set_post_responses/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPSandbox.set_post_responses/1","doc":"HTTPSandbox.set_post_responses([\n      {\"https://localhost:5000/v1/api/iserver/account\", fn ->\n        {:ok, %{\"acctId\" => \"U12345678\"}, %IbkrApi.SharedUtils.HTTP.Response{status: 200}}\n      end}\n    ])","ref":"IbkrApi.Support.HTTPSandbox.html#set_post_responses/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.set_put_responses/1","doc":"Sets sandbox responses for PUT requests.","ref":"IbkrApi.Support.HTTPSandbox.html#set_put_responses/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPSandbox.set_put_responses/1","doc":"HTTPSandbox.set_put_responses([\n      {\"https://localhost:5000/v1/api/iserver/account/orders\", fn ->\n        {:ok, %{\"id\" => \"12345\"}, %IbkrApi.SharedUtils.HTTP.Response{status: 200}}\n      end}\n    ])","ref":"IbkrApi.Support.HTTPSandbox.html#set_put_responses/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPSandbox.start_link/0","doc":"Start the HTTP sandbox registry.\nShould be called from test_helper.exs","ref":"IbkrApi.Support.HTTPSandbox.html#start_link/0"},{"type":"type","title":"IbkrApi.Support.HTTPSandbox.url/0","doc":"","ref":"IbkrApi.Support.HTTPSandbox.html#t:url/0"},{"type":"module","title":"IbkrApi.Support.HTTPStubs.AuthStub","doc":"Stub module for IbkrApi.ClientPortal.Auth HTTP requests.","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.AuthStub.stub_check_auth_status/1","doc":"Stubs the check_auth_status endpoint.","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_check_auth_status/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.AuthStub.stub_check_auth_status/1","doc":"AuthStub.stub_check_auth_status()\n    # Or with custom response:\n    AuthStub.stub_check_auth_status(HTTPMock.success(%{authenticated: true}))","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_check_auth_status/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.AuthStub.stub_end_session/1","doc":"Stubs the end_session endpoint.","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_end_session/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.AuthStub.stub_end_session/1","doc":"AuthStub.stub_end_session()\n    # Or with custom response:\n    AuthStub.stub_end_session(HTTPMock.success(%{logout: true}))","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_end_session/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.AuthStub.stub_ping_server/1","doc":"Stubs the ping_server endpoint.","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_ping_server/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.AuthStub.stub_ping_server/1","doc":"AuthStub.stub_ping_server()\n    # Or with custom response:\n    AuthStub.stub_ping_server(HTTPMock.success(%{iserver: %{auth_status: %{authenticated: true}}}))","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_ping_server/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.AuthStub.stub_reauthenticate/1","doc":"Stubs the reauthenticate endpoint.","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_reauthenticate/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.AuthStub.stub_reauthenticate/1","doc":"AuthStub.stub_reauthenticate()\n    # Or with custom response:\n    AuthStub.stub_reauthenticate(HTTPMock.success(%{authenticated: false}))","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_reauthenticate/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.AuthStub.stub_validate_sso/1","doc":"Stubs the validate_sso endpoint.","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_validate_sso/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.AuthStub.stub_validate_sso/1","doc":"AuthStub.stub_validate_sso()\n    # Or with custom response:\n    AuthStub.stub_validate_sso(HTTPMock.success(%{result: true}))","ref":"IbkrApi.Support.HTTPStubs.AuthStub.html#stub_validate_sso/1-examples"},{"type":"module","title":"IbkrApi.Support.HTTPStubs.ContractStub","doc":"Stub module for IbkrApi.ClientPortal.Contract HTTP requests.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_all_conids_by_exchange/1","doc":"Stubs the all conids by exchange endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_all_conids_by_exchange/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_contract_info/1","doc":"Stubs the contract info endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_contract_info/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_currency_pairs/1","doc":"Stubs the currency pairs endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_currency_pairs/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_exchange_rate/1","doc":"Stubs the exchange rate endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_exchange_rate/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_futures_by_symbol/1","doc":"Stubs the futures by symbol endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_futures_by_symbol/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_get_strikes/1","doc":"Stubs the get strikes endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_get_strikes/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_search_by_symbol/1","doc":"Stubs the search by symbol endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_search_by_symbol/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_search_contracts/1","doc":"Stubs the search contracts endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_search_contracts/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_secdef_by_conid/1","doc":"Stubs the secdef by conid endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_secdef_by_conid/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_stocks_by_symbol/1","doc":"Stubs the stocks by symbol endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_stocks_by_symbol/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_symbol_info/1","doc":"Stubs the symbol info endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_symbol_info/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.ContractStub.stub_trading_schedule/1","doc":"Stubs the trading schedule endpoint.","ref":"IbkrApi.Support.HTTPStubs.ContractStub.html#stub_trading_schedule/1"},{"type":"module","title":"IbkrApi.Support.HTTPStubs.MarketDataStub","doc":"Stub module for IbkrApi.ClientPortal.MarketData HTTP requests.","ref":"IbkrApi.Support.HTTPStubs.MarketDataStub.html"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.MarketDataStub.stub_get_historical_data/1","doc":"Stubs the get_historical_data endpoint.","ref":"IbkrApi.Support.HTTPStubs.MarketDataStub.html#stub_get_historical_data/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.MarketDataStub.stub_get_historical_data/1","doc":"MarketDataStub.stub_get_historical_data()\n    # Or with custom response:\n    MarketDataStub.stub_get_historical_data(fn -> HTTPMock.success(%{\"data\" => [...custom bars...]}) end)","ref":"IbkrApi.Support.HTTPStubs.MarketDataStub.html#stub_get_historical_data/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.MarketDataStub.stub_live_market_data_snapshots/1","doc":"Stubs the live_market_data_snapshots endpoint.","ref":"IbkrApi.Support.HTTPStubs.MarketDataStub.html#stub_live_market_data_snapshots/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.MarketDataStub.stub_live_market_data_snapshots/1","doc":"MarketDataStub.stub_live_market_data_snapshots()\n    # Or with custom response:\n    MarketDataStub.stub_live_market_data_snapshots(HTTPMock.success([...custom market data...]))","ref":"IbkrApi.Support.HTTPStubs.MarketDataStub.html#stub_live_market_data_snapshots/1-examples"},{"type":"module","title":"IbkrApi.Support.HTTPStubs.OrderStub","doc":"Stub module for IbkrApi.ClientPortal.Order HTTP requests.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_delete_order/1","doc":"Stubs the delete_order endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_delete_order/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_get_order_status/1","doc":"Stubs the get_order_status endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_get_order_status/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_list_orders/1","doc":"Stubs the list_orders endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_list_orders/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.OrderStub.stub_list_orders/1","doc":"OrderStub.stub_list_orders()\n    # Or with custom response:\n    OrderStub.stub_list_orders(HTTPMock.success([%{\"order_id\" => \"12345\", \"symbol\" => \"MSFT\", ...}]))","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_list_orders/1-examples"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_modify_order/1","doc":"Stubs the modify_order endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_modify_order/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_place_order/1","doc":"Stubs the place_order endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_place_order/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_place_order_for_fa_group/1","doc":"Stubs the place_order_for_fa_group endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_place_order_for_fa_group/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_place_order_reply/1","doc":"Stubs the place_order_reply endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_place_order_reply/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.OrderStub.stub_what_if/1","doc":"Stubs the what_if endpoint.","ref":"IbkrApi.Support.HTTPStubs.OrderStub.html#stub_what_if/1"},{"type":"module","title":"IbkrApi.Support.HTTPStubs.PortfolioStub","doc":"Stub module for IbkrApi.ClientPortal.Portfolio HTTP requests.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_account_allocation/1","doc":"Stubs the account_allocation endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_account_allocation/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_account_info/1","doc":"Stubs the account_info endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_account_info/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_account_ledger/1","doc":"Stubs the account_ledger endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_account_ledger/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_account_summary/1","doc":"Stubs the account_summary endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_account_summary/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_get_pnl/1","doc":"Stubs the get_pnl endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_get_pnl/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_invalidate_positions_cache/1","doc":"Stubs the invalidate_positions_cache endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_invalidate_positions_cache/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_list_accounts/1","doc":"Stubs the list_accounts endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_list_accounts/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_list_brokerage_accounts/1","doc":"Stubs the list_brokerage_accounts endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_list_brokerage_accounts/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_list_sub_accounts/1","doc":"Stubs the list_sub_accounts endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_list_sub_accounts/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_portfolio_positions/1","doc":"Stubs the portfolio_positions endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_portfolio_positions/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_position_by_conid/1","doc":"Stubs the position_by_conid endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_position_by_conid/1"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.PortfolioStub.stub_switch_account/1","doc":"Stubs the switch_account endpoint.","ref":"IbkrApi.Support.HTTPStubs.PortfolioStub.html#stub_switch_account/1"},{"type":"module","title":"IbkrApi.Support.HTTPStubs.TradeStub","doc":"Stub module for IbkrApi.ClientPortal.Trade HTTP requests.","ref":"IbkrApi.Support.HTTPStubs.TradeStub.html"},{"type":"function","title":"IbkrApi.Support.HTTPStubs.TradeStub.stub_list_trades/1","doc":"Stubs the list_trades endpoint.","ref":"IbkrApi.Support.HTTPStubs.TradeStub.html#stub_list_trades/1"},{"type":"function","title":"Examples - IbkrApi.Support.HTTPStubs.TradeStub.stub_list_trades/1","doc":"TradeStub.stub_list_trades()\n    # Or with custom response:\n    TradeStub.stub_list_trades(HTTPMock.success([%{symbol: \"MSFT\", side: \"SELL\", size: 50}]))","ref":"IbkrApi.Support.HTTPStubs.TradeStub.html#stub_list_trades/1-examples"},{"type":"behaviour","title":"IbkrApi.Websocket.Behaviour","doc":"Behaviour for WebSocket event handlers.","ref":"IbkrApi.Websocket.Behaviour.html"},{"type":"callback","title":"IbkrApi.Websocket.Behaviour.handle_event/2","doc":"","ref":"IbkrApi.Websocket.Behaviour.html#c:handle_event/2"},{"type":"module","title":"IbkrApi.ClientPortal.Auth","doc":"","ref":"IbkrApi.ClientPortal.Auth.html"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.check_auth_status/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#check_auth_status/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.end_session/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#end_session/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.ping_server/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#ping_server/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.reauthenticate/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#reauthenticate/0"},{"type":"function","title":"IbkrApi.ClientPortal.Auth.validate_sso/0","doc":"","ref":"IbkrApi.ClientPortal.Auth.html#validate_sso/0"},{"type":"module","title":"IbkrApi.ClientPortal.Contract","doc":"Contract-related functionality for the IBKR Client Portal API.\n\nThis module provides functions to retrieve contract information, trading schedules,\nsecurity definitions, and currency exchange rates.","ref":"IbkrApi.ClientPortal.Contract.html"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.contract_details/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#contract_details/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_available_currency_pairs/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_available_currency_pairs/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_contract_ids/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_ids/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_contract_info/2","doc":"Get detailed contract information using the secdef/info endpoint.\n\nReturns a list of contract information objects matching the criteria.","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_info/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.get_contract_info/2","doc":"- `conid` - Contract identifier (required)\n- `opts` - Optional parameters:\n  - `:sec_type` - Security type\n  - `:month` - Expiration month for derivatives\n  - `:exchange` - Specific exchange\n  - `:strike` - Strike price for options\n  - `:right` - \"C\" for Call, \"P\" for Put options\n  - `:issuer_id` - Issuer ID for bonds\n  - `:filters` - Comma-separated list of additional filters for bonds","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_info/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.get_contract_info/2","doc":"iex> IbkrApi.ClientPortal.Contract.get_contract_info(\"8314\")\n    {:ok, [%SecdefInfo{conid: 8314, symbol: \"IBM\", sec_type: \"STK\", ...}]}\n\n    iex> IbkrApi.ClientPortal.Contract.get_contract_info(\"265598\", sec_type: \"OPT\", strike: 250)\n    {:ok, [%SecdefInfo{conid: 795753109, symbol: \"NVDA\", right: \"C\", ...}, ...]}","ref":"IbkrApi.ClientPortal.Contract.html#get_contract_info/2-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_currency_exchange_rate/2","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_currency_exchange_rate/2"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_nyse_trading_schedule/2","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_nyse_trading_schedule/2"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_options_for_symbol/2","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_options_for_symbol/2"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_stock_security_definition/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_stock_security_definition/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_strikes/4","doc":"Get option strikes for a given contract.","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/4"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.get_strikes/4","doc":"- `contract_id`: Contract identifier of the underlying or derivative\n- `sec_type`: Security type (e.g., \"OPT\" for options)\n- `month`: Elixir Date struct representing the expiration month\n- `opts`: Optional parameters including exchange (defaults to \"SMART\")","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/4-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.get_strikes/4","doc":"iex> date = ~D[2024-01-15]\n    iex> get_strikes(\"265598\", \"OPT\", date)\n    {:ok, %StrikesResponse{call: [70, 75, 80], put: [70, 75, 80]}}","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes/4-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_strikes_by_symbol/2","doc":"Convenience function to get strikes for a symbol by first searching for the contract.\n\nThis function searches for the symbol, finds the first matching contract with options,\nthen retrieves the strikes for the current month.","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes_by_symbol/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.get_strikes_by_symbol/2","doc":"- `symbol`: The ticker symbol to search for\n- `opts`: Optional parameters:\n  - `:month`: Date struct for expiration month (defaults to current month)\n  - `:sec_type`: Security type for search (defaults to \"STK\")","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes_by_symbol/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.get_strikes_by_symbol/2","doc":"iex> get_strikes(\"AAPL\")\n    {:ok, %StrikesResponse{call: [150, 155, 160], put: [150, 155, 160]}}","ref":"IbkrApi.ClientPortal.Contract.html#get_strikes_by_symbol/2-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.get_trading_schedule/3","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#get_trading_schedule/3"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.search_contracts/2","doc":"Search for contracts based on symbol and other criteria.","ref":"IbkrApi.ClientPortal.Contract.html#search_contracts/2"},{"type":"function","title":"Parameters - IbkrApi.ClientPortal.Contract.search_contracts/2","doc":"- `symbol`: The ticker symbol, bond issuer type, or company name\n- `opts`: Optional parameters:\n  - `:sec_type`: Security type (\"STK\", \"IND\", \"BOND\") - defaults to \"STK\"\n  - `:name`: Boolean indicating if symbol is part of company name\n  - `:more`: Boolean for additional results\n  - `:fund`: Boolean for fund search\n  - `:fund_family_conid_ex`: String for fund family\n  - `:pattern`: Boolean for pattern search\n  - `:referrer`: String referrer","ref":"IbkrApi.ClientPortal.Contract.html#search_contracts/2-parameters"},{"type":"function","title":"Examples - IbkrApi.ClientPortal.Contract.search_contracts/2","doc":"iex> search_contracts(\"AAPL\")\n    {:ok, [%SearchContract{symbol: \"AAPL\", conid: \"265598\", ...}]}","ref":"IbkrApi.ClientPortal.Contract.html#search_contracts/2-examples"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.secdef_by_conid/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#secdef_by_conid/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.security_futures_by_symbol/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#security_futures_by_symbol/1"},{"type":"function","title":"IbkrApi.ClientPortal.Contract.security_stocks_by_symbol/1","doc":"","ref":"IbkrApi.ClientPortal.Contract.html#security_stocks_by_symbol/1"},{"type":"module","title":"IbkrApi.ClientPortal.Order","doc":"`IbkrApi.ClientPortal.Order` module for managing order placement and monitoring.","ref":"IbkrApi.ClientPortal.Order.html"},{"type":"function","title":"IbkrApi.ClientPortal.Order.cancel_order/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#cancel_order/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.get_live_orders/0","doc":"","ref":"IbkrApi.ClientPortal.Order.html#get_live_orders/0"},{"type":"function","title":"IbkrApi.ClientPortal.Order.get_order_status/1","doc":"","ref":"IbkrApi.ClientPortal.Order.html#get_order_status/1"},{"type":"function","title":"IbkrApi.ClientPortal.Order.modify_order/3","doc":"","ref":"IbkrApi.ClientPortal.Order.html#modify_order/3"},{"type":"function","title":"IbkrApi.ClientPortal.Order.place_orders/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#place_orders/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.place_orders_for_fa/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#place_orders_for_fa/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.preview_order/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#preview_order/2"},{"type":"function","title":"IbkrApi.ClientPortal.Order.reply_to_order_query/2","doc":"","ref":"IbkrApi.ClientPortal.Order.html#reply_to_order_query/2"},{"type":"module","title":"IbkrApi.ClientPortal.Trade","doc":"","ref":"IbkrApi.ClientPortal.Trade.html"},{"type":"function","title":"IbkrApi.ClientPortal.Trade.list_trades/0","doc":"","ref":"IbkrApi.ClientPortal.Trade.html#list_trades/0"},{"type":"module","title":"IbkrApi.Websocket","doc":"WebSocket client for Interactive Brokers Client Portal API streaming data.\n\nThis module provides a WebSocket client that connects to the IBKR Client Portal Gateway\nto receive real-time market data, order updates, and portfolio P&L streams.","ref":"IbkrApi.Websocket.html"},{"type":"module","title":"Usage - IbkrApi.Websocket","doc":"To use this module, create your own module and `use IbkrApi.Websocket`:\n\n    defmodule MyIbkrClient do\n      use IbkrApi.Websocket\n\n      def handle_event({:market_data, data}, state) do\n        IO.inspect(data, label: \"Market Data\")\n        {:ok, state}\n      end\n\n      def handle_event({:order_update, order}, state) do\n        IO.inspect(order, label: \"Order Update\")\n        {:ok, state}\n      end\n\n      def handle_event({:pnl_update, pnl}, state) do\n        IO.inspect(pnl, label: \"P&L Update\")\n        {:ok, state}\n      end\n\n      def handle_event(_event, state) do\n        {:ok, state}\n      end\n    end\n\n    # Start the WebSocket client\n    {:ok, pid} = MyIbkrClient.start_link(%{})\n\n    # Subscribe to market data for contract ID 8314 (IBM)\n    MyIbkrClient.subscribe_to_market_data(pid, [8314], [\"31\", \"83\"])\n\n    # Subscribe to order updates\n    MyIbkrClient.subscribe_to_order_updates(pid)\n\n    # Subscribe to P&L updates\n    MyIbkrClient.subscribe_to_pnl(pid)","ref":"IbkrApi.Websocket.html#module-usage"},{"type":"module","title":"Connection Requirements - IbkrApi.Websocket","doc":"Before connecting, ensure:\n1. IBKR Client Portal Gateway is running (usually on localhost:5000)\n2. You are logged in via the Gateway web interface\n3. Your account has appropriate market data subscriptions","ref":"IbkrApi.Websocket.html#module-connection-requirements"},{"type":"module","title":"Message Formats - IbkrApi.Websocket","doc":"","ref":"IbkrApi.Websocket.html#module-message-formats"},{"type":"module","title":"Market Data Subscription - IbkrApi.Websocket","doc":"- Subscribe: `smd+ +{\"fields\":[\"31\",\"83\"],\"tempo\":1000,\"snapshot\":true}`\n- Unsubscribe: `umd+ +{}`","ref":"IbkrApi.Websocket.html#module-market-data-subscription"},{"type":"module","title":"Order Updates - IbkrApi.Websocket","doc":"- Subscribe: `sor+{}`\n- Unsubscribe: `uor+{}`","ref":"IbkrApi.Websocket.html#module-order-updates"},{"type":"module","title":"P&L Updates - IbkrApi.Websocket","doc":"- Subscribe: `spl+{}`\n- Unsubscribe: `upl+{}`","ref":"IbkrApi.Websocket.html#module-p-l-updates"},{"type":"module","title":"Heartbeat - IbkrApi.Websocket","doc":"- Send: `ech+hb` (recommended every 10 seconds)","ref":"IbkrApi.Websocket.html#module-heartbeat"},{"type":"module","title":"Field IDs for Market Data - IbkrApi.Websocket","doc":"Common field IDs for market data subscriptions:\n- \"31\": Last price\n- \"83\": Percent change\n- \"84\": High\n- \"85\": Low\n- \"86\": Volume\n- \"87\": Close\n- \"88\": Bid\n- \"89\": Ask\n- \"7295\": Market cap\n- \"7296\": Company name","ref":"IbkrApi.Websocket.html#module-field-ids-for-market-data"},{"type":"module","title":"Rate Limits - IbkrApi.Websocket","doc":"IBKR limits concurrent market data streams to approximately 5 instruments per session.\nPlan your subscriptions accordingly.","ref":"IbkrApi.Websocket.html#module-rate-limits"},{"type":"module","title":"SSL Configuration - IbkrApi.Websocket","doc":"The local Gateway uses a self-signed SSL certificate. This module automatically\nconfigures SSL options to accept self-signed certificates for localhost connections.","ref":"IbkrApi.Websocket.html#module-ssl-configuration"},{"type":"function","title":"IbkrApi.Websocket.send_heartbeat/1","doc":"Sends a heartbeat message to keep the connection alive.","ref":"IbkrApi.Websocket.html#send_heartbeat/1"},{"type":"function","title":"IbkrApi.Websocket.start_link/3","doc":"Starts a WebSocket connection to the IBKR Client Portal Gateway.","ref":"IbkrApi.Websocket.html#start_link/3"},{"type":"function","title":"Options - IbkrApi.Websocket.start_link/3","doc":"- `:url` - WebSocket URL (default: \"wss://localhost:5000/v1/api/ws\")\n- `:ssl_opts` - SSL options for the connection\n- `:heartbeat` - Whether to send automatic heartbeats (default: true)","ref":"IbkrApi.Websocket.html#start_link/3-options"},{"type":"function","title":"IbkrApi.Websocket.subscribe_to_market_data/4","doc":"Subscribes to market data for the given contract IDs.","ref":"IbkrApi.Websocket.html#subscribe_to_market_data/4"},{"type":"function","title":"Parameters - IbkrApi.Websocket.subscribe_to_market_data/4","doc":"- `pid` - WebSocket process PID\n- `contract_ids` - List of contract IDs to subscribe to\n- `fields` - List of field IDs to request (e.g., [\"31\", \"83\"])\n- `opts` - Additional options:\n  - `:tempo` - Update frequency in milliseconds (default: 1000)\n  - `:snapshot` - Request initial snapshot (default: true)","ref":"IbkrApi.Websocket.html#subscribe_to_market_data/4-parameters"},{"type":"function","title":"IbkrApi.Websocket.subscribe_to_order_updates/1","doc":"Subscribes to order updates for all accounts in the current session.","ref":"IbkrApi.Websocket.html#subscribe_to_order_updates/1"},{"type":"function","title":"IbkrApi.Websocket.subscribe_to_pnl/1","doc":"Subscribes to portfolio P&L updates.","ref":"IbkrApi.Websocket.html#subscribe_to_pnl/1"},{"type":"function","title":"IbkrApi.Websocket.unsubscribe_from_market_data/2","doc":"Unsubscribes from market data for the given contract IDs.","ref":"IbkrApi.Websocket.html#unsubscribe_from_market_data/2"},{"type":"function","title":"IbkrApi.Websocket.unsubscribe_from_order_updates/1","doc":"Unsubscribes from order updates.","ref":"IbkrApi.Websocket.html#unsubscribe_from_order_updates/1"},{"type":"function","title":"IbkrApi.Websocket.unsubscribe_from_pnl/1","doc":"Unsubscribes from portfolio P&L updates.","ref":"IbkrApi.Websocket.html#unsubscribe_from_pnl/1"},{"type":"module","title":"IbkrApi.Backtester.Bar","doc":"Historical market data bar structure for backtesting.\n\nThis module provides a standardized bar structure and conversion utilities\nfor backtesting with IBKR historical data.","ref":"IbkrApi.Backtester.Bar.html"},{"type":"function","title":"IbkrApi.Backtester.Bar.bearish?/1","doc":"Returns true if the bar is bearish (close < open).","ref":"IbkrApi.Backtester.Bar.html#bearish?/1"},{"type":"function","title":"IbkrApi.Backtester.Bar.bullish?/1","doc":"Returns true if the bar is bullish (close > open).","ref":"IbkrApi.Backtester.Bar.html#bullish?/1"},{"type":"function","title":"IbkrApi.Backtester.Bar.from_historical_bar/1","doc":"Converts IbkrApi.ClientPortal.MarketData.HistoricalBar to IbkrApi.Backtester.Bar.\n\nThis provides compatibility between the IBKR API module and backtesting framework.","ref":"IbkrApi.Backtester.Bar.html#from_historical_bar/1"},{"type":"function","title":"IbkrApi.Backtester.Bar.from_ibkr/1","doc":"Converts IBKR API response data to IbkrApi.Backtester.Bar struct.","ref":"IbkrApi.Backtester.Bar.html#from_ibkr/1"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Bar.from_ibkr/1","doc":"- `data`: Map containing IBKR bar data with keys \"t\", \"o\", \"h\", \"l\", \"c\", \"v\"","ref":"IbkrApi.Backtester.Bar.html#from_ibkr/1-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Bar.from_ibkr/1","doc":"iex> IbkrApi.Backtester.Bar.from_ibkr(%{\"t\" => 1707139200000, \"o\" => 189.9, \"h\" => 190.3, \"l\" => 188.7, \"c\" => 189.5, \"v\" => 24018321})\n    %IbkrApi.Backtester.Bar{\n      timestamp: ~U[2024-02-05 13:20:00.000Z],\n      open: 189.9,\n      high: 190.3,\n      low: 188.7,\n      close: 189.5,\n      volume: 24018321\n    }","ref":"IbkrApi.Backtester.Bar.html#from_ibkr/1-examples"},{"type":"function","title":"IbkrApi.Backtester.Bar.range/1","doc":"Returns the price range (high - low) for the bar.","ref":"IbkrApi.Backtester.Bar.html#range/1"},{"type":"type","title":"IbkrApi.Backtester.Bar.t/0","doc":"","ref":"IbkrApi.Backtester.Bar.html#t:t/0"},{"type":"function","title":"IbkrApi.Backtester.Bar.typical_price/1","doc":"Returns the typical price (HLC/3) for the bar.","ref":"IbkrApi.Backtester.Bar.html#typical_price/1"},{"type":"module","title":"IbkrApi.Backtester.Engine","doc":"Backtesting engine that runs strategies against historical data.\n\nThe engine processes historical bars sequentially, calling the strategy\nfor each bar and executing the resulting trades on the portfolio.","ref":"IbkrApi.Backtester.Engine.html"},{"type":"function","title":"IbkrApi.Backtester.Engine.calculate_metrics/1","doc":"Calculates key performance metrics for a backtest result.","ref":"IbkrApi.Backtester.Engine.html#calculate_metrics/1"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Engine.calculate_metrics/1","doc":"- `result`: Result map from run/3 or run_detailed/3","ref":"IbkrApi.Backtester.Engine.html#calculate_metrics/1-parameters"},{"type":"function","title":"Returns - IbkrApi.Backtester.Engine.calculate_metrics/1","doc":"Extended performance metrics including:\n- Sharpe ratio (if portfolio_values available)\n- Maximum drawdown\n- Win rate\n- Average trade return","ref":"IbkrApi.Backtester.Engine.html#calculate_metrics/1-returns"},{"type":"function","title":"IbkrApi.Backtester.Engine.run/3","doc":"Runs a backtest with the given bars and strategy.","ref":"IbkrApi.Backtester.Engine.html#run/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Engine.run/3","doc":"- `bars`: List of historical bars (chronologically ordered, oldest first)\n- `strategy_module`: Module implementing the IbkrApi.Backtester.Strategy behaviour\n- `opts`: Optional configuration\n  - `:starting_cash` - Initial portfolio cash (default: 100,000.0)\n  - `:strategy_opts` - Options passed to strategy.init/1 (default: [])","ref":"IbkrApi.Backtester.Engine.html#run/3-parameters"},{"type":"function","title":"Returns - IbkrApi.Backtester.Engine.run/3","doc":"A map containing:\n- `:portfolio` - Final portfolio state\n- `:performance` - Performance statistics\n- `:trade_history` - List of all executed trades\n- `:bars_processed` - Number of bars processed","ref":"IbkrApi.Backtester.Engine.html#run/3-returns"},{"type":"function","title":"Examples - IbkrApi.Backtester.Engine.run/3","doc":"iex> bars = [%IbkrApi.Backtester.Bar{close: 100.0, open: 99.0, high: 101.0, low: 98.0, volume: 1000, timestamp: DateTime.utc_now()}]\n    iex> result = IbkrApi.Backtester.Engine.run(bars, IbkrApi.Backtester.Strategies.MA)\n    iex> is_map(result)\n    true","ref":"IbkrApi.Backtester.Engine.html#run/3-examples"},{"type":"function","title":"IbkrApi.Backtester.Engine.run_detailed/3","doc":"Runs a backtest and returns detailed results with bar-by-bar portfolio values.\n\nThis version tracks portfolio value at each bar for plotting and analysis.","ref":"IbkrApi.Backtester.Engine.html#run_detailed/3"},{"type":"module","title":"IbkrApi.Backtester.Portfolio","doc":"Portfolio management for backtesting.\n\nTracks cash, positions, and trade history during backtesting simulations.\nSupports simple long-only strategies with buy/sell/hold operations.","ref":"IbkrApi.Backtester.Portfolio.html"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.buy/3","doc":"Executes a buy order if no position is currently held.","ref":"IbkrApi.Backtester.Portfolio.html#buy/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.buy/3","doc":"- `portfolio`: Current portfolio state\n- `price`: Price per share to buy at\n- `timestamp`: Optional timestamp for the trade (defaults to current time)","ref":"IbkrApi.Backtester.Portfolio.html#buy/3-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.buy/3","doc":"iex> portfolio = %IbkrApi.Backtester.Portfolio{cash: 10000.0, position: 0}\n    iex> result = IbkrApi.Backtester.Portfolio.buy(portfolio, 150.0)\n    iex> result.cash\n    9850.0\n    iex> result.position\n    1\n    iex> result.entry_price\n    150.0","ref":"IbkrApi.Backtester.Portfolio.html#buy/3-examples"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.hold/1","doc":"Returns the portfolio unchanged (hold position).","ref":"IbkrApi.Backtester.Portfolio.html#hold/1"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.new/1","doc":"Creates a new portfolio with the specified starting cash.","ref":"IbkrApi.Backtester.Portfolio.html#new/1"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.new/1","doc":"iex> IbkrApi.Backtester.Portfolio.new(50_000.0)\n    %IbkrApi.Backtester.Portfolio{cash: 50000.0, position: 0, entry_price: nil, trades: []}","ref":"IbkrApi.Backtester.Portfolio.html#new/1-examples"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.performance_stats/3","doc":"Returns portfolio performance statistics.","ref":"IbkrApi.Backtester.Portfolio.html#performance_stats/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.performance_stats/3","doc":"- `portfolio`: Current portfolio state\n- `current_price`: Current market price (for unrealized P&L calculation)\n- `starting_value`: Initial portfolio value (defaults to 100,000.0)","ref":"IbkrApi.Backtester.Portfolio.html#performance_stats/3-parameters"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.realized_pnl/1","doc":"Calculates the realized P&L from completed trades.\n\nOnly considers buy/sell pairs, ignoring any open position.","ref":"IbkrApi.Backtester.Portfolio.html#realized_pnl/1"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.sell/3","doc":"Sell shares at the given price if a position is currently held.","ref":"IbkrApi.Backtester.Portfolio.html#sell/3"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.sell/3","doc":"- `portfolio`: Current portfolio state\n- `price`: Price per share to sell at\n- `timestamp`: Optional timestamp for the trade (defaults to current time)","ref":"IbkrApi.Backtester.Portfolio.html#sell/3-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.sell/3","doc":"iex> portfolio = %IbkrApi.Backtester.Portfolio{cash: 8500.0, position: 1, entry_price: 150.0}\n    iex> result = IbkrApi.Backtester.Portfolio.sell(portfolio, 160.0)\n    iex> result.cash\n    8660.0\n    iex> result.position\n    0\n    iex> result.entry_price\n    nil","ref":"IbkrApi.Backtester.Portfolio.html#sell/3-examples"},{"type":"type","title":"IbkrApi.Backtester.Portfolio.t/0","doc":"","ref":"IbkrApi.Backtester.Portfolio.html#t:t/0"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.total_value/2","doc":"Calculates the current total value of the portfolio.","ref":"IbkrApi.Backtester.Portfolio.html#total_value/2"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Portfolio.total_value/2","doc":"- `portfolio`: Current portfolio state\n- `current_price`: Current market price of the held security (if any)","ref":"IbkrApi.Backtester.Portfolio.html#total_value/2-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Portfolio.total_value/2","doc":"iex> portfolio = %IbkrApi.Backtester.Portfolio{cash: 8500.0, position: 1, entry_price: 150.0}\n    iex> IbkrApi.Backtester.Portfolio.total_value(portfolio, 160.0)\n    8660.0","ref":"IbkrApi.Backtester.Portfolio.html#total_value/2-examples"},{"type":"type","title":"IbkrApi.Backtester.Portfolio.trade/0","doc":"","ref":"IbkrApi.Backtester.Portfolio.html#t:trade/0"},{"type":"function","title":"IbkrApi.Backtester.Portfolio.unrealized_pnl/2","doc":"Calculates the unrealized P&L for the current position.\n\nReturns 0.0 if no position is held.","ref":"IbkrApi.Backtester.Portfolio.html#unrealized_pnl/2"},{"type":"module","title":"IbkrApi.Backtester.Strategies.MA","doc":"Simple Moving Average crossover strategy.\n\nGenerates buy signals when price is above the moving average\nand sell signals when price is below the moving average.","ref":"IbkrApi.Backtester.Strategies.MA.html"},{"type":"function","title":"IbkrApi.Backtester.Strategies.MA.calculate_sma/2","doc":"Calculates Simple Moving Average for the given bars.","ref":"IbkrApi.Backtester.Strategies.MA.html#calculate_sma/2"},{"type":"function","title":"Parameters - IbkrApi.Backtester.Strategies.MA.calculate_sma/2","doc":"- `bars`: List of bars (most recent first)\n- `window`: Number of periods to average","ref":"IbkrApi.Backtester.Strategies.MA.html#calculate_sma/2-parameters"},{"type":"function","title":"Examples - IbkrApi.Backtester.Strategies.MA.calculate_sma/2","doc":"iex> bars = [%{close: 100}, %{close: 102}, %{close: 98}]\n    iex> IbkrApi.Backtester.Strategies.MA.calculate_sma(bars, 3)\n    100.0","ref":"IbkrApi.Backtester.Strategies.MA.html#calculate_sma/2-examples"},{"type":"function","title":"IbkrApi.Backtester.Strategies.MA.init/1","doc":"Initialize the strategy with configuration options.","ref":"IbkrApi.Backtester.Strategies.MA.html#init/1"},{"type":"function","title":"Options - IbkrApi.Backtester.Strategies.MA.init/1","doc":"- `:window` - Moving average window size (default: 5)","ref":"IbkrApi.Backtester.Strategies.MA.html#init/1-options"},{"type":"function","title":"Examples - IbkrApi.Backtester.Strategies.MA.init/1","doc":"iex> IbkrApi.Backtester.Strategies.MA.init(window: 10)\n    %{window: 10}","ref":"IbkrApi.Backtester.Strategies.MA.html#init/1-examples"},{"type":"function","title":"IbkrApi.Backtester.Strategies.MA.signal/3","doc":"Generates trading signals based on moving average crossover.","ref":"IbkrApi.Backtester.Strategies.MA.html#signal/3"},{"type":"function","title":"Logic - IbkrApi.Backtester.Strategies.MA.signal/3","doc":"- Buy when current price > moving average\n- Sell when current price < moving average  \n- Hold when price equals moving average or insufficient data","ref":"IbkrApi.Backtester.Strategies.MA.html#signal/3-logic"},{"type":"behaviour","title":"IbkrApi.Backtester.Strategy","doc":"Behaviour for defining backtesting strategies.\n\nStrategies implement the `signal/3` callback to generate buy/sell/hold signals\nbased on current market data and historical context.","ref":"IbkrApi.Backtester.Strategy.html"},{"type":"callback","title":"IbkrApi.Backtester.Strategy.init/1","doc":"Optional callback for strategy initialization.\n\nCalled once before backtesting begins. Can be used to set up\ninitial state, validate parameters, etc.\n\nDefault implementation returns an empty map.","ref":"IbkrApi.Backtester.Strategy.html#c:init/1"},{"type":"callback","title":"IbkrApi.Backtester.Strategy.signal/3","doc":"Generates a trading signal based on current bar and historical data.","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3"},{"type":"callback","title":"Parameters - IbkrApi.Backtester.Strategy.signal/3","doc":"- `current_bar`: The current bar being processed\n- `previous_bars`: List of previous bars (most recent first)\n- `state`: Strategy-specific state map for maintaining indicators, etc.","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3-parameters"},{"type":"callback","title":"Returns - IbkrApi.Backtester.Strategy.signal/3","doc":"A tuple containing the signal (`:buy`, `:sell`, or `:hold`) and updated state.","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3-returns"},{"type":"callback","title":"Examples - IbkrApi.Backtester.Strategy.signal/3","doc":"def signal(bar, prev_bars, state) do\n      if bar.close > calculate_sma(prev_bars, 20) do\n        {:buy, state}\n      else\n        {:sell, state}\n      end\n    end","ref":"IbkrApi.Backtester.Strategy.html#c:signal/3-examples"},{"type":"module","title":"IbkrApi","doc":"# IbkrApi\n\nA comprehensive Elixir client for Interactive Brokers' Client Portal API. This library provides a clean, idiomatic Elixir interface to interact with Interactive Brokers' trading platform.","ref":"IbkrApi.html"},{"type":"module","title":"Features - IbkrApi","doc":"- Complete API coverage for Interactive Brokers' Client Portal API\n- Authentication and session management\n- Account information and portfolio management\n- Order placement and management\n- Market data and contract information\n- Trading operations\n- Profile management\n\nSee the [README](https://github.com/MikaAK/ibkr_api) for more information.","ref":"IbkrApi.html#module-features"},{"type":"module","title":"IbkrApi.Config","doc":"Configuration settings for the IBKR API client.\n\nThis module provides functions to access configuration values with sensible defaults.\nValues can be overridden in your application configuration.","ref":"IbkrApi.Config.html"},{"type":"module","title":"Example Configuration - IbkrApi.Config","doc":"```elixir\nconfig :ibkr_api,\n  host: \"https://localhost\",\n  port: \"5050\",\n  rate_limits: [\n    global: [limit: 45, time_window_ms: 1_000],\n    endpoints: [\n      iserver_marketdata_snapshot: [limit: 9, time_window_ms: 1_000],\n      # ... other endpoint-specific limits\n    ]\n  ]\n```","ref":"IbkrApi.Config.html#module-example-configuration"},{"type":"function","title":"IbkrApi.Config.base_url/0","doc":"Returns the base URL for the IBKR API.","ref":"IbkrApi.Config.html#base_url/0"},{"type":"function","title":"IbkrApi.Config.default_rate_limits/0","doc":"Returns the default rate limit configuration.","ref":"IbkrApi.Config.html#default_rate_limits/0"},{"type":"function","title":"IbkrApi.Config.host/0","doc":"Returns the configured host or the default value.","ref":"IbkrApi.Config.html#host/0"},{"type":"function","title":"IbkrApi.Config.port/0","doc":"Returns the configured port or the default value.","ref":"IbkrApi.Config.html#port/0"},{"type":"function","title":"IbkrApi.Config.rate_limit/0","doc":"Returns the rate limiting configuration.\n\nRate limits can be configured via application environment:\n\n    config :ibkr_api, :rate_limits,\n      global: [limit: 50, time_window_ms: 1_000],\n      endpoints: [\n        iserver_marketdata_snapshot: [limit: 10, time_window_ms: 1_000],\n        iserver_scanner_run: [limit: 1, time_window_ms: 1_000]\n      ]\n\nIf no configuration is provided, defaults are returned.","ref":"IbkrApi.Config.html#rate_limit/0"},{"type":"function","title":"IbkrApi.Config.rate_limit/1","doc":"Returns the rate limit configuration for a specific endpoint or global limit.","ref":"IbkrApi.Config.html#rate_limit/1"},{"type":"function","title":"Parameters - IbkrApi.Config.rate_limit/1","doc":"- key: Atom representing either `:global` or an endpoint name like `:iserver_marketdata_snapshot`","ref":"IbkrApi.Config.html#rate_limit/1-parameters"},{"type":"function","title":"Returns - IbkrApi.Config.rate_limit/1","doc":"- %{limit: integer, time_window_ms: integer} containing rate limit configuration","ref":"IbkrApi.Config.html#rate_limit/1-returns"},{"type":"function","title":"IbkrApi.Config.validate_rate_limits/1","doc":"Validates the rate limit configuration.\n\nReturns `{:ok, validated_config}` if the configuration is valid,\nor `{:error, error}` if the configuration is invalid.","ref":"IbkrApi.Config.html#validate_rate_limits/1"},{"type":"module","title":"IbkrApi.HTTP","doc":"HTTP client for the Interactive Brokers Client Portal API with rate limiting.\n\nThis module provides functions to make rate-limited HTTP requests to the IBKR API.\nRate limits are enforced both globally and per-endpoint according to IBKR's documentation.","ref":"IbkrApi.HTTP.html"},{"type":"function","title":"IbkrApi.HTTP.child_spec/1","doc":"Returns a child specification for the HTTP client.","ref":"IbkrApi.HTTP.html#child_spec/1"},{"type":"function","title":"IbkrApi.HTTP.delete/3","doc":"Makes a rate-limited DELETE request to the specified URL.","ref":"IbkrApi.HTTP.html#delete/3"},{"type":"function","title":"Parameters - IbkrApi.HTTP.delete/3","doc":"- url: The URL to request\n  - headers: HTTP headers to include\n  - opts: Additional options","ref":"IbkrApi.HTTP.html#delete/3-parameters"},{"type":"function","title":"IbkrApi.HTTP.extract_path/1","doc":"Extracts the API path from a URL.","ref":"IbkrApi.HTTP.html#extract_path/1"},{"type":"function","title":"IbkrApi.HTTP.get/3","doc":"Makes a rate-limited GET request to the specified URL.","ref":"IbkrApi.HTTP.html#get/3"},{"type":"function","title":"Parameters - IbkrApi.HTTP.get/3","doc":"- url: The URL to request\n  - headers: HTTP headers to include\n  - opts: Additional options","ref":"IbkrApi.HTTP.html#get/3-parameters"},{"type":"function","title":"IbkrApi.HTTP.post/4","doc":"Makes a rate-limited POST request to the specified URL.","ref":"IbkrApi.HTTP.html#post/4"},{"type":"function","title":"Parameters - IbkrApi.HTTP.post/4","doc":"- url: The URL to request\n  - body: The request body\n  - headers: HTTP headers to include\n  - opts: Additional options","ref":"IbkrApi.HTTP.html#post/4-parameters"},{"type":"function","title":"IbkrApi.HTTP.put/4","doc":"Makes a rate-limited PUT request to the specified URL.","ref":"IbkrApi.HTTP.html#put/4"},{"type":"function","title":"Parameters - IbkrApi.HTTP.put/4","doc":"- url: The URL to request\n  - body: The request body\n  - headers: HTTP headers to include\n  - opts: Additional options","ref":"IbkrApi.HTTP.html#put/4-parameters"},{"type":"function","title":"IbkrApi.HTTP.with_rate_limiting/2","doc":"Applies rate limiting to the given function based on the URL.","ref":"IbkrApi.HTTP.html#with_rate_limiting/2"},{"type":"extras","title":"IbkrApi","doc":"# IbkrApi\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ibkr_api.svg)](https://hex.pm/packages/ibkr_api)\n[![Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/ibkr_api)\n[![License](https://img.shields.io/badge/license-MIT-blue.svg)](https://opensource.org/licenses/MIT)\n\nA comprehensive Elixir client for Interactive Brokers' Client Portal API. This library provides a clean, idiomatic Elixir interface to interact with Interactive Brokers' trading platform.","ref":"readme.html"},{"type":"extras","title":"Features - IbkrApi","doc":"- Complete API coverage for Interactive Brokers' Client Portal API\n- Authentication and session management\n- Account information and portfolio management\n- Order placement and management\n- Market data and contract information\n- Trading operations\n- Profile management","ref":"readme.html#features"},{"type":"extras","title":"Installation - IbkrApi","doc":"Add `ibkr_api` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ibkr_api, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Quick Start - IbkrApi","doc":"```elixir\n# Authenticate with the IBKR Client Portal API\n{:ok, auth_response} = IbkrApi.ClientPortal.Auth.ping_server()\n\n# List your accounts\n{:ok, accounts} = IbkrApi.ClientPortal.Account.list_accounts()\n\n# Get account summary\naccount_id = hd(accounts).account_id\n{:ok, summary} = IbkrApi.ClientPortal.Account.account_summary(account_id)\n```","ref":"readme.html#quick-start"},{"type":"extras","title":"Documentation - IbkrApi","doc":"- **Tutorials**: Step-by-step guides to get you started\n  - [Getting Started](https://hexdocs.pm/ibkr_api/getting_started.html)\n  - [Authentication](https://hexdocs.pm/ibkr_api/authentication.html)\n\n- **How-To Guides**: Practical guides for specific tasks\n  - [Account Management](https://hexdocs.pm/ibkr_api/account_management.html)\n  - [Trading](https://hexdocs.pm/ibkr_api/trading.html)\n\n- **Reference**: Technical information and API details\n  - [API Reference](https://hexdocs.pm/ibkr_api/api_reference.html)\n\n- **Explanation**: Background information and concepts\n  - [Architecture](https://hexdocs.pm/ibkr_api/architecture.html)","ref":"readme.html#documentation"},{"type":"extras","title":"Prerequisites - IbkrApi","doc":"To use this library, you need:\n\n1. **Interactive Brokers account** - Active IBKR brokerage account\n2. **Java Runtime Environment** - Java 8 update 192 or later for the Client Portal Gateway\n3. **Client Portal Gateway** - Download and run locally:\n   - [Standard Release](https://download2.interactivebrokers.com/portal/clientportal.gw.zip)\n   - [Beta Release](https://download2.interactivebrokers.com/portal/clientportal.beta.gw.zip)\n4. **Elixir 1.15 or later**","ref":"readme.html#prerequisites"},{"type":"extras","title":"Contributing - IbkrApi","doc":"Contributions are welcome! Please feel free to submit a Pull Request.","ref":"readme.html#contributing"},{"type":"extras","title":"License - IbkrApi","doc":"This project is licensed under the MIT License - see the LICENSE file for details.","ref":"readme.html#license"},{"type":"extras","title":"Getting Started with IbkrApi","doc":"# Getting Started with IbkrApi\n\nThis tutorial will guide you through the process of setting up and using the IbkrApi library to interact with Interactive Brokers' Client Portal API.\n\n> #### Prerequisites {: .info}\n>\n> Before you begin, make sure you have:\n>\n> 1. **An Interactive Brokers account** with appropriate permissions\n> 2. **The Client Portal Gateway** running locally or on a server\n> 3. **Elixir 1.15 or later** installed on your system\n> 4. **Java 8 Update 192+** for running the Client Portal Gateway","ref":"getting_started.html"},{"type":"extras","title":"Installation - Getting Started with IbkrApi","doc":"Add `ibkr_api` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ibkr_api, \"~> 0.1.0\"}\n  ]\nend\n```\n\nThen run:\n\n```bash\nmix deps.get\n```","ref":"getting_started.html#installation"},{"type":"extras","title":"Configuration - Getting Started with IbkrApi","doc":"Configure the library in your application's configuration file (`config/config.exs`):\n\n```elixir\nconfig :ibkr_api,\n  host: \"https://localhost\",  # Default Client Portal Gateway host\n  port: 5000,  # Default Client Portal Gateway port\n  timeout: 30_000  # Request timeout in milliseconds\n```\n\nYou can override these settings in your environment-specific configuration files.","ref":"getting_started.html#configuration"},{"type":"extras","title":"Starting the Client Portal Gateway - Getting Started with IbkrApi","doc":"Before using the library, you need to start the Interactive Brokers Client Portal Gateway:","ref":"getting_started.html#starting-the-client-portal-gateway"},{"type":"extras","title":"Prerequisites - Getting Started with IbkrApi","doc":"1. **Java Runtime Environment (JRE)**: The gateway requires Java 8 update 192 or later. Check if Java is installed:\n   ```bash\n   java -version\n   ```\n   If not installed, download from the [official Java website](https://www.java.com/en/download/)","ref":"getting_started.html#prerequisites"},{"type":"extras","title":"Download and Setup - Getting Started with IbkrApi","doc":"2. **Download the Client Portal Gateway**:\n   - [Standard Release](https://download2.interactivebrokers.com/portal/clientportal.gw.zip) (recommended)\n   - [Beta Release](https://download2.interactivebrokers.com/portal/clientportal.beta.gw.zip) (if you experience issues with standard)\n\n3. **Extract and run the gateway**:\n   ```bash\n   # Extract the downloaded file\n   unzip clientportal.gw.zip\n   cd clientportal.gw\n   \n   # On Unix/Linux/macOS:\n   bin/run.sh root/conf.yaml\n   \n   # On Windows:\n   bin\\run.bat root\\conf.yaml\n   ```\n\n> #### Important Security Notes {: .warning}\n>\n> - **Same-machine requirement**: The gateway must run on the same machine where you'll make API calls\n> - **Default port**: 5000 (configurable in `root/conf.yaml`)\n> - **Browser authentication**: You must authenticate through the browser on the same machine\n> - **SSL certificates**: The gateway uses self-signed certificates by default","ref":"getting_started.html#download-and-setup"},{"type":"extras","title":"Basic Usage - Getting Started with IbkrApi","doc":"","ref":"getting_started.html#basic-usage"},{"type":"extras","title":"Establishing a Connection - Getting Started with IbkrApi","doc":"First, you need to authenticate with the IBKR Client Portal API using `IbkrApi.ClientPortal.Auth`:\n\n```elixir\n# Check if the server is running and authenticate\n{:ok, response} = IbkrApi.ClientPortal.Auth.ping_server()\n\n# If you need to reauthenticate\n{:ok, _} = IbkrApi.ClientPortal.Auth.reauthenticate()\n```","ref":"getting_started.html#establishing-a-connection"},{"type":"extras","title":"Listing Accounts - Getting Started with IbkrApi","doc":"Once authenticated, you can list your accounts using `IbkrApi.ClientPortal.Portfolio`:\n\n```elixir\n{:ok, accounts} = IbkrApi.ClientPortal.Portfolio.list_accounts()\n\n# Print account IDs\naccounts |> Enum.each(fn account -> IO.puts(account.account_id) end)\n```","ref":"getting_started.html#listing-accounts"},{"type":"extras","title":"Getting Account Information - Getting Started with IbkrApi","doc":"You can retrieve detailed information about a specific account using `IbkrApi.ClientPortal.Portfolio`:\n\n```elixir\naccount_id = \"U1234567\"  # Replace with your actual account ID\n{:ok, summary} = IbkrApi.ClientPortal.Portfolio.account_summary(account_id)\n\n# Access summary data (returns a map with account fields)\nIO.inspect(summary, label: \"Account Summary\")\n```\n\n> #### Next Steps {: .tip}\n>\n> Now that you've set up the library and made your first API calls, you can:\n>\n> 1. Learn more about [Authentication](authentication.html) processes\n> 2. Explore [Account Management](../how-to/account_management.html) operations  \n> 3. Start [Trading](../how-to/trading.html) with the API\n> 4. Set up [WebSocket Streaming](../how-to/websocket_streaming.html) for real-time data\n>\n> For a complete reference of all available functions, check the [API Reference](../reference/api_reference.html).","ref":"getting_started.html#getting-account-information"},{"type":"extras","title":"Authentication with IbkrApi","doc":"# Authentication with IbkrApi\n\nThis tutorial explains how to authenticate with the Interactive Brokers Client Portal API using the IbkrApi library.","ref":"authentication.html"},{"type":"extras","title":"Understanding IBKR Authentication - Authentication with IbkrApi","doc":"> #### Session-Based Authentication {: .info}\n>\n> The Interactive Brokers Client Portal API uses a session-based authentication system. Before making API calls, you need to:\n>\n> 1. **Start the Client Portal Gateway**\n> 2. **Authenticate through the gateway's web interface**\n> 3. **Maintain your authenticated session**","ref":"authentication.html#understanding-ibkr-authentication"},{"type":"extras","title":"Initial Authentication - Authentication with IbkrApi","doc":"When you first start the Client Portal Gateway, you need to authenticate through its web interface:\n\n1. **Download and start the gateway**:\n   - Download: [Standard Release](https://download2.interactivebrokers.com/portal/clientportal.gw.zip) or [Beta Release](https://download2.interactivebrokers.com/portal/clientportal.beta.gw.zip)\n   - Ensure Java 8+ is installed: `java -version`\n   - Extract and run: `bin/run.sh root/conf.yaml` (Unix) or `bin\\run.bat root\\conf.yaml` (Windows)\n\n2. **Authenticate via browser**:\n   - Open a browser and navigate to `http://localhost:5000`\n   - Log in with your Interactive Brokers credentials\n   \n   > #### Critical Authentication Requirement {: .warning}\n   >\n   > Authentication **must** be done on the same machine where the gateway is running. Remote authentication will not work due to security restrictions.\n\n3. After successful login, you can start using the IbkrApi library","ref":"authentication.html#initial-authentication"},{"type":"extras","title":"Session Management with IbkrApi - Authentication with IbkrApi","doc":"","ref":"authentication.html#session-management-with-ibkrapi"},{"type":"extras","title":"Checking Authentication Status - Authentication with IbkrApi","doc":"To check if your session is still valid:\n\n```elixir\n{:ok, status} = IbkrApi.ClientPortal.Auth.check_auth_status()\n\nif status.authenticated do\n  IO.puts(\"Session is active\")\nelse\n  IO.puts(\"Session needs to be re-authenticated\")\nend\n```","ref":"authentication.html#checking-authentication-status"},{"type":"extras","title":"Pinging the Server - Authentication with IbkrApi","doc":"The `ping_server/0` function is a convenient way to check both connectivity and authentication status:\n\n```elixir\ncase IbkrApi.ClientPortal.Auth.ping_server() do\n  {:ok, response} ->\n    if response.iserver.auth_status.authenticated do\n      IO.puts(\"Connected and authenticated\")\n    else\n      IO.puts(\"Connected but not authenticated\")\n    end\n  \n  {:error, reason} ->\n    IO.puts(\"Connection error: #{inspect(reason)}\")\nend\n```","ref":"authentication.html#pinging-the-server"},{"type":"extras","title":"Re-authentication Flow - Authentication with IbkrApi","doc":"When your session expires, you'll need to re-authenticate. Here's the proper flow:\n\n1. **Check authentication status first**:\n\n```elixir\n{:ok, status} = IbkrApi.ClientPortal.Auth.check_auth_status()\n\ncase status do\n  %IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse{authenticated: false} ->\n    # Session expired, need to re-authenticate\n    IO.puts(\"Session expired, re-authenticating...\")\n    \n  %IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse{authenticated: true} ->\n    # Session is still valid\n    IO.puts(\"Session is active\")\nend\n```\n\n2. **When authentication is false, follow this sequence**:\n\n```elixir\n# Step 1: Call reauthenticate\n{:ok, reauth_response} = IbkrApi.ClientPortal.Auth.reauthenticate()\n\n# Step 2: Call validate_sso\n{:ok, sso_response} = IbkrApi.ClientPortal.Auth.validate_sso()\n\nIO.puts(\"Re-authentication complete\")\n```\n\n3. **Complete re-authentication helper function**:\n\n```elixir\ndef handle_reauthentication do\n  case IbkrApi.ClientPortal.Auth.check_auth_status() do\n    {:ok, %IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse{authenticated: false}} ->\n      # Session expired, re-authenticate\n      with {:ok, _reauth} <- IbkrApi.ClientPortal.Auth.reauthenticate(),\n           {:ok, _sso} <- IbkrApi.ClientPortal.Auth.validate_sso() do\n        {:ok, :reauthenticated}\n      else\n        {:error, reason} -> {:error, {:reauthentication_failed, reason}}\n      end\n      \n    {:ok, %IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse{authenticated: true}} ->\n      {:ok, :already_authenticated}\n      \n    {:error, reason} ->\n      {:error, {:check_status_failed, reason}}\n  end\nend\n```\n\n**Important Notes:**\n- Always call `reauthenticate/0` first, then `validate_sso/0`\n- Re-authentication may not work if your session has been expired for too long\n- In such cases, you'll need to log in again through the web interface at `http://localhost:5000`","ref":"authentication.html#re-authentication-flow"},{"type":"extras","title":"Validating SSO - Authentication with IbkrApi","doc":"For applications using Single Sign-On (SSO):\n\n```elixir\n{:ok, sso_info} = IbkrApi.ClientPortal.Auth.validate_sso()\n\nIO.puts(\"User: #{sso_info.user_name}\")\nIO.puts(\"Expires: #{sso_info.expires}\")\n```","ref":"authentication.html#validating-sso"},{"type":"extras","title":"Ending Your Session - Authentication with IbkrApi","doc":"When you're done using the API, it's good practice to end your session:\n\n```elixir\n{:ok, _} = IbkrApi.ClientPortal.Auth.end_session()\n```","ref":"authentication.html#ending-your-session"},{"type":"extras","title":"Authentication Flow in Production - Authentication with IbkrApi","doc":"In a production environment, you might want to implement a more robust authentication flow:\n\n```elixir\ndefmodule MyApp.IbkrAuthManager do\n  def ensure_authenticated do\n    case IbkrApi.ClientPortal.Auth.check_auth_status() do\n      {:ok, %{authenticated: true}} ->\n        {:ok, :authenticated}\n        \n      {:ok, %{authenticated: false}} ->\n        # Try to reauthenticate\n        case IbkrApi.ClientPortal.Auth.reauthenticate() do\n          {:ok, %{message: \"Authenticated\"}} -> {:ok, :reauthenticated}\n          _ -> {:error, :authentication_required}\n        end\n        \n      {:error, reason} ->\n        {:error, reason}\n    end\n  end\nend\n```","ref":"authentication.html#authentication-flow-in-production"},{"type":"extras","title":"Session Timeout Considerations - Authentication with IbkrApi","doc":"Interactive Brokers sessions typically time out after a period of inactivity. To maintain an active session:\n\n1. Implement a periodic ping to the server (e.g., every 5 minutes)\n2. Handle reauthentication automatically when needed\n3. Have a fallback mechanism for when reauthentication fails","ref":"authentication.html#session-timeout-considerations"},{"type":"extras","title":"Next Steps - Authentication with IbkrApi","doc":"Now that you understand how to manage authentication with the IBKR API, you can:\n\n1. Learn about [Account Management](../how-to/account_management.html)\n2. Start [Trading](../how-to/trading.html) with the API\n3. Explore the [API Reference](../reference/api_reference.html) for more details","ref":"authentication.html#next-steps"},{"type":"extras","title":"Account Management","doc":"# Account Management\n\nThis guide covers common account management tasks using the IbkrApi library.","ref":"account_management.html"},{"type":"extras","title":"Listing Accounts - Account Management","doc":"To retrieve all accounts associated with your Interactive Brokers login:\n\n```elixir\n{:ok, accounts} = IbkrApi.ClientPortal.Portfolio.list_accounts()\n\n# Process the accounts\naccounts |> Enum.each(fn account ->\n  IO.puts(\"Account ID: #{account.account_id}\")\n  IO.puts(\"Account Title: #{account.account_title}\")\n  IO.puts(\"Account Type: #{account.type}\")\n  IO.puts(\"---\")\nend)\n```","ref":"account_management.html#listing-accounts"},{"type":"extras","title":"Retrieving Account Details - Account Management","doc":"","ref":"account_management.html#retrieving-account-details"},{"type":"extras","title":"Account Summary - Account Management","doc":"To get a comprehensive summary of an account:\n\n```elixir\naccount_id = \"U1234567\"  # Replace with your actual account ID\n{:ok, summary} = IbkrApi.ClientPortal.Portfolio.account_summary(account_id)\n\n# Access common summary information\nIO.puts(\"Available Funds: #{summary.available_funds}\")\nIO.puts(\"Buying Power: #{summary.buying_power}\")\nIO.puts(\"Equity with Loan Value: #{summary.equity_with_loan_value}\")\nIO.puts(\"Excess Liquidity: #{summary.excess_liquidity}\")\n```","ref":"account_management.html#account-summary"},{"type":"extras","title":"Account Ledger - Account Management","doc":"To retrieve the account ledger information:\n\n```elixir\n{:ok, ledger} = IbkrApi.ClientPortal.Portfolio.account_ledger(account_id)\n\n# Access ledger information for the base currency\nbase_currency = ledger.BASE\nIO.puts(\"Cash Balance: #{base_currency.cashbalance}\")\nIO.puts(\"Net Liquidation Value: #{base_currency.netliquidationvalue}\")\nIO.puts(\"Realized P&L: #{base_currency.realizedpnl}\")\nIO.puts(\"Unrealized P&L: #{base_currency.unrealizedpnl}\")\n```","ref":"account_management.html#account-ledger"},{"type":"extras","title":"Working with Sub-Accounts - Account Management","doc":"If you have a master account with sub-accounts:","ref":"account_management.html#working-with-sub-accounts"},{"type":"extras","title":"Listing Sub-Accounts - Account Management","doc":"```elixir\n{:ok, sub_accounts} = IbkrApi.ClientPortal.Portfolio.list_sub_accounts()\n\n# Process sub-accounts\nsub_accounts |> Enum.each(fn sub_account ->\n  IO.puts(\"Sub-Account ID: #{sub_account.account_id}\")\n  IO.puts(\"Sub-Account Title: #{sub_account.account_title}\")\n  IO.puts(\"---\")\nend)\n```","ref":"account_management.html#listing-sub-accounts"},{"type":"extras","title":"Listing Large Sub-Accounts with Pagination - Account Management","doc":"For accounts with many sub-accounts:\n\n```elixir\n# Get the first page\n{:ok, large_sub_accounts} = IbkrApi.ClientPortal.Portfolio.list_brokerage_accounts()\n\n# Display metadata\nIO.puts(\"Total Sub-Accounts: #{large_sub_accounts.metadata.total}\")\nIO.puts(\"Page Size: #{large_sub_accounts.metadata.page_size}\")\n\n# Process sub-accounts on this page\nlarge_sub_accounts.subaccounts |> Enum.each(fn sub_account ->\n  IO.puts(\"Sub-Account ID: #{sub_account.account_id}\")\nend)\n\n# Get the next page if needed\nif large_sub_accounts.metadata.total > large_sub_accounts.metadata.page_size do\n  {:ok, next_page} = IbkrApi.ClientPortal.Account.list_large_sub_accounts(\"1\")\n  # Process next page...\nend\n```","ref":"account_management.html#listing-large-sub-accounts-with-pagination"},{"type":"extras","title":"Switching Between Accounts - Account Management","doc":"If you need to switch the active account for subsequent API calls:\n\n```elixir\ntarget_account_id = \"U7654321\"  # Replace with the account ID you want to switch to\n{:ok, switch_response} = IbkrApi.ClientPortal.Portfolio.switch_account(target_account_id)\n\nif switch_response.set do\n  IO.puts(\"Successfully switched to account #{switch_response.acctId}\")\nelse\n  IO.puts(\"Failed to switch account\")\nend\n```","ref":"account_management.html#switching-between-accounts"},{"type":"extras","title":"Retrieving Profit and Loss Information - Account Management","doc":"To get P&L information for your account:\n\n```elixir\n{:ok, pnl_response} = IbkrApi.ClientPortal.Portfolio.get_pnl()\n\n# Process P&L data\naccount_ids = Map.keys(pnl_response.acctId)\naccount_ids |> Enum.each(fn account_id ->\n  account_pnl = pnl_response.acctId[account_id]\n  IO.puts(\"Account: #{account_id}\")\n  IO.puts(\"P&L data: #{inspect(account_pnl)}\")\n  IO.puts(\"---\")\nend)\n```","ref":"account_management.html#retrieving-profit-and-loss-information"},{"type":"extras","title":"Error Handling - Account Management","doc":"All API functions return `{:ok, result}` on success and `{:error, reason}` on failure. It's good practice to handle errors appropriately:\n\n```elixir\ncase IbkrApi.ClientPortal.Portfolio.account_summary(account_id) do\n  {:ok, summary} ->\n    # Process the summary...\n    IO.puts(\"Available Funds: #{summary.available_funds}\")\n    \n  {:error, %ErrorMessage{code: code, message: message}} ->\n    IO.puts(\"Error #{code}: #{message}\")\n    \n    # Handle specific error codes\n    case code do\n      \"1015\" -> IO.puts(\"Account not found or not authorized\")\n      \"1021\" -> IO.puts(\"Session expired, please reauthenticate\")\n      _ -> IO.puts(\"Unknown error\")\n    end\nend\n```","ref":"account_management.html#error-handling"},{"type":"extras","title":"Best Practices - Account Management","doc":"1. **Cache account information** when appropriate to reduce API calls\n2. **Check authentication status** before making account-related calls\n3. **Handle pagination** properly when dealing with large datasets\n4. **Implement proper error handling** for all API calls\n5. **Respect API rate limits** to avoid being temporarily blocked","ref":"account_management.html#best-practices"},{"type":"extras","title":"Related Resources - Account Management","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Trading](trading.html)\n- [API Reference](../reference/api_reference.html)","ref":"account_management.html#related-resources"},{"type":"extras","title":"Trading with IbkrApi","doc":"# Trading with IbkrApi\n\nThis guide covers how to perform trading operations using the IbkrApi library, including placing orders, modifying orders, and retrieving order status.\n\n> #### Important Trading Prerequisites {: .warning}\n>\n> Before placing any orders, ensure you have:\n> - **Valid IBKR account** with trading permissions\n> - **Client Portal Gateway** running and authenticated\n> - **Sufficient funds** in your account\n> - **Market data subscriptions** for the instruments you want to trade","ref":"trading.html"},{"type":"extras","title":"Finding Contracts - Trading with IbkrApi","doc":"Before placing an order, you need to find the contract you want to trade using `IbkrApi.ClientPortal.Contract`:\n\n```elixir\n# Search for a stock by symbol\nsymbol = \"AAPL\"\n{:ok, contracts} = IbkrApi.ClientPortal.Contract.search_contracts(symbol)\n\n# Process the search results\ncontracts |> Enum.each(fn contract ->\n  IO.puts(\"Contract: #{contract.symbol}\")\n  IO.puts(\"Description: #{contract.description}\")\n  IO.puts(\"Contract ID: #{contract.conid}\")\n  IO.puts(\"---\")\nend)\n\n# Get the contract ID for use in orders\ncontract_id = List.first(contracts).conid\n```","ref":"trading.html#finding-contracts"},{"type":"extras","title":"Placing Orders - Trading with IbkrApi","doc":"Use `IbkrApi.ClientPortal.Order.place_orders/2` to submit orders to IBKR:\n\n<!-- tabs-open -->","ref":"trading.html#placing-orders"},{"type":"extras","title":"Market Order - Trading with IbkrApi","doc":"```elixir\n# Define the order parameters\norder_params = %{\n  acctId: \"U1234567\",  # Replace with your actual account ID\n  conid: 265598,       # Contract ID for the instrument\n  orderType: \"MKT\",    # Market order\n  side: \"BUY\",         # BUY or SELL\n  quantity: 100,       # Number of shares/contracts\n  tif: \"DAY\"           # Time in force\n}\n\n# Place the order\n{:ok, order_response} = IbkrApi.ClientPortal.Order.place_orders(\"U1234567\", [order_params])\n\n# Get the order ID for future reference\norder_id = hd(order_response).order_id\nIO.puts(\"Order placed with ID: #{order_id}\")\n```","ref":"trading.html#market-order"},{"type":"extras","title":"Limit Order - Trading with IbkrApi","doc":"```elixir\nlimit_order_params = %{\n  acctId: \"U1234567\",\n  conid: 265598,\n  orderType: \"LMT\",    # Limit order\n  side: \"BUY\",\n  quantity: 100,\n  price: 150.25,       # Limit price\n  tif: \"DAY\"\n}\n\n{:ok, order_response} = IbkrApi.ClientPortal.Order.place_orders(\"U1234567\", [limit_order_params])\n```","ref":"trading.html#limit-order"},{"type":"extras","title":"Stop Order - Trading with IbkrApi","doc":"```elixir\nstop_order_params = %{\n  acctId: \"U1234567\",\n  conid: 265598,\n  orderType: \"STP\",    # Stop order\n  side: \"SELL\",\n  quantity: 100,\n  auxPrice: 145.50,    # Stop price\n  tif: \"GTC\"           # Good Till Canceled\n}\n\n{:ok, order_response} = IbkrApi.ClientPortal.Order.place_orders(\"U1234567\", [stop_order_params])\n```\n\n<!-- tabs-close -->","ref":"trading.html#stop-order"},{"type":"extras","title":"Checking Order Status - Trading with IbkrApi","doc":"To check the status of your orders:\n\n```elixir\n# Get all live orders\n{:ok, orders} = IbkrApi.ClientPortal.Order.get_live_orders()\n\n# Process the orders\norders |> Enum.each(fn order ->\n  IO.puts(\"Order ID: #{order.order_id}\")\n  IO.puts(\"Status: #{order.status}\")\n  IO.puts(\"Contract: #{order.symbol}\")\n  IO.puts(\"Side: #{order.side}\")\n  IO.puts(\"Quantity: #{order.quantity}\")\n  IO.puts(\"---\")\nend)\n```","ref":"trading.html#checking-order-status"},{"type":"extras","title":"Modifying Orders - Trading with IbkrApi","doc":"To modify an existing order:\n\n```elixir\n# Order ID from the original order placement\norder_id = \"1234567890\"\n\n# New parameters for the order\nmodified_params = %{\n  acctId: \"U1234567\",\n  conid: 265598,\n  orderType: \"LMT\",\n  side: \"BUY\",\n  quantity: 150,       # Updated quantity\n  price: 148.75,       # Updated price\n  tif: \"DAY\"\n}\n\n{:ok, modified_response} = IbkrApi.ClientPortal.Order.modify_order(order_id, modified_params)\n```","ref":"trading.html#modifying-orders"},{"type":"extras","title":"Canceling Orders - Trading with IbkrApi","doc":"To cancel an order:\n\n```elixir\norder_id = \"1234567890\"\n{:ok, cancel_response} = IbkrApi.ClientPortal.Order.cancel_order(order_id)\n\nif cancel_response.success do\n  IO.puts(\"Order successfully canceled\")\nelse\n  IO.puts(\"Failed to cancel order: #{cancel_response.error}\")\nend\n```","ref":"trading.html#canceling-orders"},{"type":"extras","title":"Retrieving Executions - Trading with IbkrApi","doc":"To get information about executed trades:\n\n```elixir\n# Get executions for a specific account\naccount_id = \"U1234567\"\n{:ok, executions} = IbkrApi.ClientPortal.Trade.get_executions(account_id)\n\n# Process the executions\nexecutions |> Enum.each(fn execution ->\n  IO.puts(\"Execution ID: #{execution.execution_id}\")\n  IO.puts(\"Symbol: #{execution.symbol}\")\n  IO.puts(\"Side: #{execution.side}\")\n  IO.puts(\"Quantity: #{execution.quantity}\")\n  IO.puts(\"Price: #{execution.price}\")\n  IO.puts(\"Time: #{execution.time}\")\n  IO.puts(\"---\")\nend)\n```","ref":"trading.html#retrieving-executions"},{"type":"extras","title":"Order Types and Parameters - Trading with IbkrApi","doc":"Interactive Brokers supports a wide range of order types. Here are some common ones:\n\n| Order Type | Description | Required Parameters |\n|------------|-------------|---------------------|\n| MKT | Market Order | conid, side, quantity |\n| LMT | Limit Order | conid, side, quantity, price |\n| STP | Stop Order | conid, side, quantity, auxPrice |\n| STOP_LIMIT | Stop Limit Order | conid, side, quantity, price, auxPrice |\n| TRAIL | Trailing Stop | conid, side, quantity, auxPrice (trail amount) |","ref":"trading.html#order-types-and-parameters"},{"type":"extras","title":"Time in Force Options - Trading with IbkrApi","doc":"| TIF | Description |\n|-----|-------------|\n| DAY | Valid for the day |\n| GTC | Good Till Canceled |\n| IOC | Immediate or Cancel |\n| FOK | Fill or Kill |","ref":"trading.html#time-in-force-options"},{"type":"extras","title":"Error Handling - Trading with IbkrApi","doc":"> #### Always Handle Errors {: .warning}\n>\n> Order placement can fail for various reasons. Always use pattern matching to handle both success and error cases.\n\n```elixir\ncase IbkrApi.ClientPortal.Order.place_orders(\"U1234567\", [order_params]) do\n  {:ok, order_response} ->\n    IO.puts(\"Order placed successfully: #{inspect(order_response)}\")\n    \n  {:error, %{message: message}} ->\n    IO.puts(\"Order failed: #{message}\")\n    # Handle the error appropriately\nend\n```\n\n> #### Common Error Scenarios {: .info}\n>\n> - **Insufficient funds**: Account doesn't have enough buying power\n> - **Invalid contract**: Contract ID doesn't exist or is not tradeable\n> - **Market closed**: Trying to place orders outside trading hours\n> - **Permission denied**: Account doesn't have permission to trade the instrument","ref":"trading.html#error-handling"},{"type":"extras","title":"Best Practices - Trading with IbkrApi","doc":"> #### Follow Best Practices {: .tip}\n>\n> To ensure a smooth trading experience, follow these guidelines:\n\n1. **Validate contract information** before placing orders\n2. **Start with small orders** when testing new strategies\n3. **Implement proper error handling** for all trading operations\n4. **Check order status** after placement to ensure it was accepted\n5. **Use paper trading accounts** for testing and development\n6. **Respect API rate limits** to avoid being temporarily blocked","ref":"trading.html#best-practices"},{"type":"extras","title":"Related Resources - Trading with IbkrApi","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Account Management](account_management.html)\n- [API Reference](../reference/api_reference.html)","ref":"trading.html#related-resources"},{"type":"extras","title":"WebSocket Streaming Guide","doc":"# WebSocket Streaming Guide\n\nThis guide explains how to use the IBKR WebSocket API for real-time streaming data including market data, order updates, and portfolio P&L.\n\n> #### Prerequisites {: .info}\n>\n> Before using WebSocket streaming, ensure you have:\n>\n> 1. **IBKR Client Portal Gateway running** - Download and start the gateway from:\n>    - [Standard Release](https://download2.interactivebrokers.com/portal/clientportal.gw.zip)\n>    - [Beta Release](https://download2.interactivebrokers.com/portal/clientportal.beta.gw.zip)\n>\n> 2. **Valid IBKR login** - Log in through the gateway web interface (usually https://localhost:5000)\n>\n> 3. **Market data subscriptions** - Ensure your account has appropriate market data permissions\n>\n> 4. **Java 8 Update 192+** - Required to run the Client Portal Gateway","ref":"websocket_streaming.html"},{"type":"extras","title":"Quick Start - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#quick-start"},{"type":"extras","title":"1. Create Your WebSocket Client - WebSocket Streaming Guide","doc":"```elixir\ndefmodule MyTradingBot do\n  use IbkrApi.Websocket\n  require Logger\n\n  def handle_event({:market_data, data}, state) do\n    Logger.info(\"Price update for #{data.contract_id}: #{data.fields[\"31\"]}\")\n    # Your trading logic here\n    {:ok, state}\n  end\n\n  def handle_event({:order_update, order}, state) do\n    Logger.info(\"Order update: #{inspect(order.data)}\")\n    # Handle order fills, cancellations, etc.\n    {:ok, state}\n  end\n\n  def handle_event({:pnl_update, pnl}, state) do\n    Logger.info(\"P&L: Daily=#{pnl.daily_pnl}, Unrealized=#{pnl.unrealized_pnl}\")\n    # Monitor portfolio performance\n    {:ok, state}\n  end\n\n  def handle_event(_event, state) do\n    {:ok, state}\n  end\nend\n```","ref":"websocket_streaming.html#1-create-your-websocket-client"},{"type":"extras","title":"2. Start the Client and Subscribe - WebSocket Streaming Guide","doc":"```elixir\n# Start the WebSocket client\n{:ok, pid} = MyTradingBot.start_link(%{})\n\n# Subscribe to market data for Apple (AAPL)\n# First, get the contract ID\n{:ok, contracts} = IbkrApi.ClientPortal.Contract.search_contracts(\"AAPL\")\ncontract_id = hd(contracts).contract_id\n\n# Subscribe to last price (31) and percent change (83)\nMyTradingBot.subscribe_to_market_data(pid, [contract_id], [\"31\", \"83\"])\n\n# Subscribe to order updates\nMyTradingBot.subscribe_to_order_updates(pid)\n\n# Subscribe to P&L updates\nMyTradingBot.subscribe_to_pnl(pid)\n```","ref":"websocket_streaming.html#2-start-the-client-and-subscribe"},{"type":"extras","title":"Market Data Streaming - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#market-data-streaming"},{"type":"extras","title":"Field IDs - WebSocket Streaming Guide","doc":"Common field IDs for market data subscriptions:\n\n| Field ID | Description |\n|----------|-------------|\n| \"31\" | Last price |\n| \"83\" | Percent change |\n| \"84\" | High |\n| \"85\" | Low |\n| \"86\" | Volume |\n| \"87\" | Close |\n| \"88\" | Bid |\n| \"89\" | Ask |\n| \"7295\" | Market cap |\n| \"7296\" | Company name |","ref":"websocket_streaming.html#field-ids"},{"type":"extras","title":"Subscription Options - WebSocket Streaming Guide","doc":"```elixir\n# Basic subscription\nMyTradingBot.subscribe_to_market_data(pid, [contract_id], [\"31\", \"83\"])\n\n# With custom options\nMyTradingBot.subscribe_to_market_data(pid, [contract_id], [\"31\", \"83\"], %{\n  tempo: 500,      # Update every 500ms (default: 1000)\n  snapshot: true   # Request initial snapshot (default: true)\n})\n\n# Multiple contracts\ncontract_ids = [8314, 265598, 76792]  # IBM, AAPL, MSFT\nMyTradingBot.subscribe_to_market_data(pid, contract_ids, [\"31\", \"83\"])\n```","ref":"websocket_streaming.html#subscription-options"},{"type":"extras","title":"Handling Market Data - WebSocket Streaming Guide","doc":"```elixir\ndef handle_event({:market_data, data}, state) do\n  %{\n    contract_id: contract_id,\n    fields: fields,\n    timestamp: timestamp\n  } = data\n\n  # Extract specific fields\n  last_price = Map.get(fields, \"31\")\n  percent_change = Map.get(fields, \"83\")\n  volume = Map.get(fields, \"86\")\n\n  # Your logic here\n  if last_price do\n    Logger.info(\"#{contract_id}: $#{last_price}\")\n  end\n\n  {:ok, state}\nend\n```","ref":"websocket_streaming.html#handling-market-data"},{"type":"extras","title":"Order Updates - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#order-updates"},{"type":"extras","title":"Subscribing to Orders - WebSocket Streaming Guide","doc":"```elixir\n# Subscribe to all order updates for your accounts\nMyTradingBot.subscribe_to_order_updates(pid)\n```","ref":"websocket_streaming.html#subscribing-to-orders"},{"type":"extras","title":"Handling Order Updates - WebSocket Streaming Guide","doc":"```elixir\ndef handle_event({:order_update, order}, state) do\n  %{\n    topic: topic,\n    data: order_data,\n    timestamp: timestamp\n  } = order\n\n  # Extract order information\n  order_id = Map.get(order_data, \"orderId\")\n  status = Map.get(order_data, \"status\")\n  filled_quantity = Map.get(order_data, \"filledQuantity\")\n\n  case status do\n    \"Filled\" ->\n      Logger.info(\"Order #{order_id} filled: #{filled_quantity} shares\")\n      # Handle fill logic\n    \n    \"Cancelled\" ->\n      Logger.info(\"Order #{order_id} cancelled\")\n      # Handle cancellation logic\n    \n    _ ->\n      Logger.info(\"Order #{order_id} status: #{status}\")\n  end\n\n  {:ok, state}\nend\n```","ref":"websocket_streaming.html#handling-order-updates"},{"type":"extras","title":"Portfolio P&L Updates - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#portfolio-p-l-updates"},{"type":"extras","title":"Subscribing to P&L - WebSocket Streaming Guide","doc":"```elixir\n# Subscribe to portfolio P&L updates\nMyTradingBot.subscribe_to_pnl(pid)\n```","ref":"websocket_streaming.html#subscribing-to-p-l"},{"type":"extras","title":"Handling P&L Updates - WebSocket Streaming Guide","doc":"```elixir\ndef handle_event({:pnl_update, pnl}, state) do\n  %{\n    daily_pnl: daily_pnl,\n    unrealized_pnl: unrealized_pnl,\n    data: full_data,\n    timestamp: timestamp\n  } = pnl\n\n  # Monitor portfolio performance\n  total_pnl = (daily_pnl || 0) + (unrealized_pnl || 0)\n  \n  Logger.info(\"Portfolio P&L: $#{total_pnl}\")\n  \n  # Risk management logic\n  if total_pnl < -1000 do\n    Logger.warn(\"Portfolio down $#{abs(total_pnl)} - consider risk management\")\n  end\n\n  {:ok, state}\nend\n```","ref":"websocket_streaming.html#handling-p-l-updates"},{"type":"extras","title":"Advanced Usage - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#advanced-usage"},{"type":"extras","title":"Custom WebSocket URL - WebSocket Streaming Guide","doc":"```elixir\n# Connect to remote gateway\n{:ok, pid} = MyTradingBot.start_link(%{}, url: \"wss://api.ibkr.com/v1/api/ws\")\n\n# Custom SSL options\n{:ok, pid} = MyTradingBot.start_link(%{}, \n  url: \"wss://localhost:5000/v1/api/ws\",\n  ssl_opts: [verify: :verify_none]\n)\n```","ref":"websocket_streaming.html#custom-websocket-url"},{"type":"extras","title":"Disable Automatic Heartbeat - WebSocket Streaming Guide","doc":"```elixir\n# Disable automatic heartbeat and send manually\n{:ok, pid} = MyTradingBot.start_link(%{}, heartbeat: false)\n\n# Send heartbeat manually\nMyTradingBot.send_heartbeat(pid)\n```","ref":"websocket_streaming.html#disable-automatic-heartbeat"},{"type":"extras","title":"State Management - WebSocket Streaming Guide","doc":"```elixir\ndefmodule StatefulTradingBot do\n  use IbkrApi.Websocket\n\n  def handle_event({:market_data, data}, state) do\n    # Update state with new price data\n    new_state = Map.put(state, :last_price, Map.get(data.fields, \"31\"))\n    \n    # Make trading decisions based on state\n    if should_trade?(new_state) do\n      place_order(data.contract_id, new_state)\n    end\n    \n    {:ok, new_state}\n  end\n\n  defp should_trade?(state) do\n    # Your trading logic here\n    false\n  end\n\n  defp place_order(contract_id, state) do\n    # Place order using the regular API\n    IbkrApi.ClientPortal.Order.place_order(%{\n      conid: contract_id,\n      orderType: \"MKT\",\n      side: \"BUY\",\n      quantity: 100\n    })\n  end\nend\n```","ref":"websocket_streaming.html#state-management"},{"type":"extras","title":"Error Handling - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#error-handling"},{"type":"extras","title":"Connection Issues - WebSocket Streaming Guide","doc":"```elixir\ndefmodule RobustTradingBot do\n  use IbkrApi.Websocket\n\n  def handle_disconnect(%{reason: reason}, state) do\n    Logger.error(\"WebSocket disconnected: #{inspect(reason)}\")\n    \n    # Implement reconnection logic\n    Process.send_after(self(), :reconnect, 5000)\n    \n    {:ok, state}\n  end\n\n  def handle_info(:reconnect, state) do\n    Logger.info(\"Attempting to reconnect...\")\n    # Reconnection logic here\n    {:ok, state}\n  end\nend\n```","ref":"websocket_streaming.html#connection-issues"},{"type":"extras","title":"Message Parsing Errors - WebSocket Streaming Guide","doc":"```elixir\ndef handle_event({:unknown, data}, state) do\n  Logger.warn(\"Unknown message type: #{inspect(data)}\")\n  {:ok, state}\nend\n\ndef handle_event({:raw, data}, state) do\n  Logger.warn(\"Raw message without topic: #{inspect(data)}\")\n  {:ok, state}\nend\n```","ref":"websocket_streaming.html#message-parsing-errors"},{"type":"extras","title":"Rate Limits and Best Practices - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#rate-limits-and-best-practices"},{"type":"extras","title":"Rate Limits - WebSocket Streaming Guide","doc":"- **Market Data**: Maximum ~5 concurrent subscriptions per session\n- **Connection**: One WebSocket connection per session\n- **Heartbeat**: Send every 10 seconds to maintain connection\n\n> #### Rate Limits {: .warning}\n>\n> IBKR limits market data subscriptions to approximately **5 concurrent streams per session**. Exceeding this limit may result in connection issues or data delays.","ref":"websocket_streaming.html#rate-limits"},{"type":"extras","title":"Best Practices - WebSocket Streaming Guide","doc":"> #### Performance Tips {: .tip}\n>\n> - **Unsubscribe** from unused streams to free up slots\n> - **Batch subscriptions** when possible  \n> - **Monitor connection** health with heartbeat\n> - **Handle reconnections** gracefully\n> - **Use appropriate log levels** (debug for verbose data)","ref":"websocket_streaming.html#best-practices"},{"type":"extras","title":"Example: Rotating Subscriptions - WebSocket Streaming Guide","doc":"```elixir\ndefmodule RotatingBot do\n  use IbkrApi.Websocket\n\n  def rotate_subscriptions(pid, old_contracts, new_contracts) do\n    # Unsubscribe from old contracts\n    MyTradingBot.unsubscribe_from_market_data(pid, old_contracts)\n    \n    # Subscribe to new contracts\n    MyTradingBot.subscribe_to_market_data(pid, new_contracts, [\"31\", \"83\"])\n  end\nend\n```","ref":"websocket_streaming.html#example-rotating-subscriptions"},{"type":"extras","title":"Troubleshooting - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#troubleshooting"},{"type":"extras","title":"Common Issues - WebSocket Streaming Guide","doc":"1. **Connection Refused**: Ensure the Client Portal Gateway is running\n2. **SSL Errors**: Use `ssl_opts: [verify: :verify_none]` for localhost\n3. **No Data**: Check market data subscriptions and trading hours\n4. **Authentication**: Ensure you're logged in via the gateway web interface","ref":"websocket_streaming.html#common-issues"},{"type":"extras","title":"Debug Logging - WebSocket Streaming Guide","doc":"```elixir\n# Enable debug logging\nLogger.configure(level: :debug)\n\ndef handle_event(event, state) do\n  Logger.debug(\"Received event: #{inspect(event)}\")\n  {:ok, state}\nend\n```","ref":"websocket_streaming.html#debug-logging"},{"type":"extras","title":"Integration with Trading Strategies - WebSocket Streaming Guide","doc":"","ref":"websocket_streaming.html#integration-with-trading-strategies"},{"type":"extras","title":"Example: Moving Average Crossover - WebSocket Streaming Guide","doc":"```elixir\ndefmodule MACrossoverBot do\n  use IbkrApi.Websocket\n\n  def handle_event({:market_data, data}, state) do\n    price = Map.get(data.fields, \"31\")\n    \n    if price do\n      new_state = update_moving_averages(state, data.contract_id, price)\n      \n      if crossover_signal?(new_state, data.contract_id) do\n        execute_trade(data.contract_id, new_state)\n      end\n      \n      {:ok, new_state}\n    else\n      {:ok, state}\n    end\n  end\n\n  defp update_moving_averages(state, contract_id, price) do\n    # Update price history and calculate moving averages\n    # Implementation details...\n    state\n  end\n\n  defp crossover_signal?(state, contract_id) do\n    # Check for MA crossover signal\n    # Implementation details...\n    false\n  end\n\n  defp execute_trade(contract_id, state) do\n    # Execute trade via the Order API\n    # Implementation details...\n  end\nend\n```\n\nThis WebSocket implementation provides a robust foundation for real-time trading applications with the IBKR API.","ref":"websocket_streaming.html#example-moving-average-crossover"},{"type":"extras","title":"Testing with HTTP Mocks","doc":"# Testing with HTTP Mocks\n\nThis guide explains how to use the HTTP mocking system when writing tests for the IBKR API client.\n\n> #### Why Use HTTP Mocks? {: .info}\n>\n> The IBKR API client uses a registry-based HTTP mocking system called `HTTPSandbox` to simulate HTTP responses during testing. This approach allows tests to run without making actual HTTP requests to the IBKR API servers, making them **faster**, **more reliable**, and **independent of external services**.","ref":"testing_with_http_mocks.html"},{"type":"extras","title":"Overview - Testing with HTTP Mocks","doc":"The mocking system consists of:\n\n1. **`HTTPSandbox`** - A registry that stores mock HTTP responses\n2. **`HTTPMock`** - Helper functions for creating different types of responses\n3. **Stub Modules** - Convenience modules that provide functions for mocking specific API endpoints","ref":"testing_with_http_mocks.html#overview"},{"type":"extras","title":"Setting Up Tests - Testing with HTTP Mocks","doc":"","ref":"testing_with_http_mocks.html#setting-up-tests"},{"type":"extras","title":"Starting the Sandbox Registry - Testing with HTTP Mocks","doc":"The HTTPSandbox registry is automatically started in `test_helper.exs`. Make sure your test helper includes:\n\n```elixir\n# Start the HTTPSandbox registry for HTTP mocks\nIbkrApi.Support.HTTPSandbox.start_link()\n```","ref":"testing_with_http_mocks.html#starting-the-sandbox-registry"},{"type":"extras","title":"Using Stub Modules - Testing with HTTP Mocks","doc":"The easiest way to mock HTTP endpoints is to use the provided stub modules:\n\n- `IbkrApi.Support.HTTPStubs.AuthStub`\n- `IbkrApi.Support.HTTPStubs.ContractStub`\n- `IbkrApi.Support.HTTPStubs.MarketDataStub`\n- `IbkrApi.Support.HTTPStubs.OrderStub`\n- `IbkrApi.Support.HTTPStubs.PortfolioStub`\n- `IbkrApi.Support.HTTPStubs.TradeStub`","ref":"testing_with_http_mocks.html#using-stub-modules"},{"type":"extras","title":"Example: Using Default Mocks - Testing with HTTP Mocks","doc":"```elixir\n# Import the stub module\nalias IbkrApi.Support.HTTPStubs.AuthStub\n\n# Set up the default mock\nAuthStub.stub_auth_status()\n\n# Call the function that uses the HTTP endpoint\n{:ok, status} = IbkrApi.ClientPortal.Auth.auth_status()\n```","ref":"testing_with_http_mocks.html#example-using-default-mocks"},{"type":"extras","title":"Example: Using Custom Response - Testing with HTTP Mocks","doc":"```elixir\nalias IbkrApi.Support.HTTPStubs.AuthStub\nalias IbkrApi.Support.HTTPMock\n\n# Create a custom response\ncustom_status = %{\n  \"authenticated\" => false,\n  \"competing\" => true,\n  \"message\" => \"Competing session\"\n}\n\n# Use the custom response in the mock\nAuthStub.stub_auth_status(fn -> HTTPMock.success(custom_status) end)\n\n# Call the function\n{:ok, status} = IbkrApi.ClientPortal.Auth.auth_status()\n```","ref":"testing_with_http_mocks.html#example-using-custom-response"},{"type":"extras","title":"Creating Different Response Types - Testing with HTTP Mocks","doc":"","ref":"testing_with_http_mocks.html#creating-different-response-types"},{"type":"extras","title":"Success Response - Testing with HTTP Mocks","doc":"```elixir\n# Simple success response\nHTTPMock.success(%{\"status\" => \"ok\"})\n\n# Success response with custom status code\nHTTPMock.success(%{\"status\" => \"created\"}, 201)\n```","ref":"testing_with_http_mocks.html#success-response"},{"type":"extras","title":"Error Response - Testing with HTTP Mocks","doc":"```elixir\n# Error response\nHTTPMock.error(%{\"error\" => \"Not found\"}, 404)\n```","ref":"testing_with_http_mocks.html#error-response"},{"type":"extras","title":"Network Error - Testing with HTTP Mocks","doc":"```elixir\n# Network error\nHTTPMock.network_error(:timeout)\nHTTPMock.network_error(:nxdomain)\nHTTPMock.network_error(:econnrefused)\n```","ref":"testing_with_http_mocks.html#network-error"},{"type":"extras","title":"Testing Different Scenarios - Testing with HTTP Mocks","doc":"","ref":"testing_with_http_mocks.html#testing-different-scenarios"},{"type":"extras","title":"Testing Success Cases - Testing with HTTP Mocks","doc":"```elixir\ntest \"returns authentication status with default mock\" do\n  # Mock the auth_status HTTP call with default response\n  AuthStub.stub_auth_status()\n  \n  # Call the function\n  assert {:ok, status} = Auth.auth_status()\n  \n  # Verify response\n  assert status.authenticated\nend\n```","ref":"testing_with_http_mocks.html#testing-success-cases"},{"type":"extras","title":"Testing Error Handling - Testing with HTTP Mocks","doc":"```elixir\ntest \"handles error response\" do\n  # Mock an error response\n  error_response = %{\"error\" => \"Unable to retrieve authentication status\", \"code\" => 1234}\n  AuthStub.stub_auth_status(fn -> HTTPMock.error(error_response, 400) end)\n  \n  # Call the function\n  assert {:error, error} = Auth.auth_status()\n  assert error.status == 400\nend\n```","ref":"testing_with_http_mocks.html#testing-error-handling"},{"type":"extras","title":"Testing Network Errors - Testing with HTTP Mocks","doc":"```elixir\ntest \"handles network error\" do\n  # Mock a network error\n  AuthStub.stub_auth_status(fn -> HTTPMock.network_error(:timeout) end)\n  \n  # Call the function\n  assert {:error, :timeout} = Auth.auth_status()\nend\n```","ref":"testing_with_http_mocks.html#testing-network-errors"},{"type":"extras","title":"Testing Complex Workflows - Testing with HTTP Mocks","doc":"You can set up multiple mocks to test complex workflows:\n\n```elixir\ntest \"chaining multiple auth operations\" do\n  # Set up multiple stubs for a workflow test\n  AuthStub.stub_auth_status()\n  AuthStub.stub_validate()\n  AuthStub.stub_tickle()\n  AuthStub.stub_logout()\n  \n  # Check auth status\n  assert {:ok, status} = Auth.auth_status()\n  assert status.authenticated\n  \n  # Validate session\n  assert {:ok, validation} = Auth.validate()\n  assert validation.success\n  \n  # Tickle session\n  assert {:ok, tickle_result} = Auth.tickle()\n  assert tickle_result.success\n  \n  # Logout\n  assert {:ok, logout_result} = Auth.logout()\n  assert logout_result.success\nend\n```","ref":"testing_with_http_mocks.html#testing-complex-workflows"},{"type":"extras","title":"Creating Custom Stub Functions - Testing with HTTP Mocks","doc":"If you need to mock an endpoint that doesn't have a stub function yet, you can create one:\n\n```elixir\n# In your test module\nalias IbkrApi.Support.HTTPSandbox\n\ndef setup_custom_endpoint_mock(response_fn \\\\ nil) do\n  default_response = fn -> HTTPMock.success(%{\"data\" => \"default\"}) end\n  response = response_fn || default_response\n  \n  HTTPSandbox.set_get_responses([\n    {~r|/v1/api/custom/endpoint|, response}\n  ])\nend\n```","ref":"testing_with_http_mocks.html#creating-custom-stub-functions"},{"type":"extras","title":"Advanced: URL Pattern Matching - Testing with HTTP Mocks","doc":"Stub functions use regular expressions to match URLs, which allows for flexible mocking:\n\n```elixir\n# Match exact URL\nHTTPSandbox.set_get_responses([{\"/v1/api/exact/path\", response_fn}])\n\n# Match URL with parameter\nHTTPSandbox.set_get_responses([{~r|/v1/api/items/\\d+|, response_fn}])\n\n# Match URL with query parameters\nHTTPSandbox.set_get_responses([{~r|/v1/api/search\\?query=.*|, response_fn}])\n```","ref":"testing_with_http_mocks.html#advanced-url-pattern-matching"},{"type":"extras","title":"Implementing New Stub Modules - Testing with HTTP Mocks","doc":"If you need to create a new stub module for another API category, follow this pattern:\n\n```elixir\ndefmodule IbkrApi.Support.HTTPStubs.NewStub do\n  @moduledoc \"\"\"\n  HTTP stubs for the New API endpoints.\n  \"\"\"\n  \n  alias IbkrApi.Support.HTTPSandbox\n  alias IbkrApi.Support.HTTPMock\n  \n  @default_response %{\n    \"result\" => \"success\",\n    \"data\" => %{}\n  }\n  \n  def stub_new_endpoint(response_fn \\\\ nil) do\n    default_response = fn -> HTTPMock.success(@default_response) end\n    response = response_fn || default_response\n    \n    HTTPSandbox.set_get_responses([\n      {~r|/v1/api/new/endpoint|, response}\n    ])\n  end\nend\n```","ref":"testing_with_http_mocks.html#implementing-new-stub-modules"},{"type":"extras","title":"Test Example - Testing with HTTP Mocks","doc":"Here's a complete example of a test file using HTTP mocks:\n\n```elixir\ndefmodule IbkrApi.ClientPortal.AuthTest do\n  use ExUnit.Case\n  \n  alias IbkrApi.ClientPortal.Auth\n  alias IbkrApi.Support.HTTPMock\n  alias IbkrApi.Support.HTTPStubs.AuthStub\n\n  describe \"auth_status/0\" do\n    test \"returns authentication status with default mock\" do\n      AuthStub.stub_auth_status()\n      \n      assert {:ok, status} = Auth.auth_status()\n      assert status.authenticated\n    end\n    \n    test \"returns custom authentication status\" do\n      custom_status = %{\n        \"authenticated\" => false,\n        \"competing\" => true,\n        \"message\" => \"Competing session\"\n      }\n      \n      AuthStub.stub_auth_status(fn -> HTTPMock.success(custom_status) end)\n      \n      assert {:ok, status} = Auth.auth_status()\n      assert status.authenticated == false\n    end\n  end\nend\n```","ref":"testing_with_http_mocks.html#test-example"},{"type":"extras","title":"Working with Struct Responses - Testing with HTTP Mocks","doc":"API functions return structured Elixir data using structs, not raw maps. Test assertions should use struct field access notation (`.field`) instead of map access notation (`[\"field\"]`).","ref":"testing_with_http_mocks.html#working-with-struct-responses"},{"type":"extras","title":"❌ Incorrect (Using Map Keys): - Testing with HTTP Mocks","doc":"```elixir\nassert {:ok, status} = Auth.check_auth_status()\nassert status[\"authenticated\"]\nassert status[\"serverInfo\"][\"serverName\"] != nil\n```","ref":"testing_with_http_mocks.html#incorrect-using-map-keys"},{"type":"extras","title":"✅ Correct (Using Struct Fields): - Testing with HTTP Mocks","doc":"```elixir\nassert {:ok, status} = Auth.check_auth_status()\nassert %Auth.CheckAuthStatusResponse{} = status  # Verify the struct type\nassert status.authenticated\nassert status.server_info.server_name != nil\n```","ref":"testing_with_http_mocks.html#correct-using-struct-fields"},{"type":"extras","title":"Troubleshooting - Testing with HTTP Mocks","doc":"","ref":"testing_with_http_mocks.html#troubleshooting"},{"type":"extras","title":"Common Issues - Testing with HTTP Mocks","doc":"1. **Incorrect HTTP Method**: Ensure you're using the correct HTTP method (GET, POST, PUT, DELETE) in your stubs:\n\n   ```elixir\n   # For GET endpoints\n   HTTPSandbox.set_get_responses([{pattern, response_fn}])\n   \n   # For POST endpoints\n   HTTPSandbox.set_post_responses([{pattern, response_fn}])\n   ```\n\n2. **Mismatched Return Values**: Ensure your test assertions match the actual function return signatures:\n\n   ```elixir\n   # If the function returns {:ok, struct}\n   assert {:ok, result} = Module.function()\n   \n   # If the function returns {:ok, struct, response}\n   assert {:ok, result, response} = Module.function()\n   ```\n\n4. **Pattern Not Matching**: If your stub isn't being used, check the URL pattern:\n\n   ```elixir\n   # Debug by inspecting the request URL\n   IbkrApi.Support.HTTPSandbox.set_get_responses([\n     {~r|/path/to/endpoint|, fn url ->\n       HTTPMock.success(%{})\n     end}\n   ])\n   ```","ref":"testing_with_http_mocks.html#common-issues"},{"type":"extras","title":"Summary - Testing with HTTP Mocks","doc":"- Use `HTTPSandbox` to store and retrieve mock HTTP responses\n- Use stub modules like `AuthStub` for convenience functions\n- Create default or custom responses with `HTTPMock` helpers\n- Mock different response types: success, error, and network errors\n- Test complex workflows by setting up multiple endpoint mocks\n- Assert on struct fields (`.field`) not map keys (`[\"key\"]`)\n- Always validate struct types with pattern matching","ref":"testing_with_http_mocks.html#summary"},{"type":"extras","title":"IBKR Backtesting Framework","doc":"# IBKR Backtesting Framework\n\nA comprehensive backtesting framework for the IBKR API Elixir library. Test your trading strategies against historical market data with detailed performance analytics.","ref":"backtesting.html"},{"type":"extras","title":"Overview - IBKR Backtesting Framework","doc":"The backtesting framework consists of several key modules:\n\n- **`Backtester.Bar`** - Historical market data structure\n- **`Backtester.Portfolio`** - Portfolio management and P&L tracking\n- **`Backtester.Strategy`** - Behavior for implementing trading strategies\n- **`Backtester.Engine`** - Backtesting execution engine\n- **`Backtester.Example`** - Usage examples and utilities","ref":"backtesting.html#overview"},{"type":"extras","title":"Quick Start - IBKR Backtesting Framework","doc":"","ref":"backtesting.html#quick-start"},{"type":"extras","title":"1. Basic Backtest Example - IBKR Backtesting Framework","doc":"```elixir\n# Run a simple moving average strategy on Apple stock\n{:ok, result} = Backtester.Example.run_backtest(\"AAPL\", \"3mo\", \"1day\")\n\n# Print detailed report\nBacktester.Example.print_report(result)\n```","ref":"backtesting.html#1-basic-backtest-example"},{"type":"extras","title":"2. Sample Backtest (No API Required) - IBKR Backtesting Framework","doc":"```elixir\n# Test with synthetic data\nresult = Backtester.Example.run_sample_backtest(\n  strategy: Backtester.Strategies.MA,\n  strategy_opts: [window: 20]\n)\n\nBacktester.Example.print_report(result)\n```","ref":"backtesting.html#2-sample-backtest-no-api-required"},{"type":"extras","title":"Detailed Usage - IBKR Backtesting Framework","doc":"","ref":"backtesting.html#detailed-usage"},{"type":"extras","title":"Fetching Historical Data - IBKR Backtesting Framework","doc":"```elixir\n# Get historical data from IBKR API\nalias IbkrApi.ClientPortal.MarketData\n\n{:ok, bars} = MarketData.get_historical_data(\"265598\", \"1mo\", \"1day\")\n\n# Convert to backtester format\nbacktest_bars = Enum.map(bars, &Backtester.Bar.from_ibkr/1)\n```","ref":"backtesting.html#fetching-historical-data"},{"type":"extras","title":"Running a Backtest - IBKR Backtesting Framework","doc":"```elixir\nalias Backtester.{Engine, Strategies}\n\n# Basic backtest\nresult = Engine.run(backtest_bars, Strategies.MA, \n  starting_cash: 50_000.0,\n  strategy_opts: [window: 10]\n)\n\n# Detailed backtest with bar-by-bar tracking\ndetailed_result = Engine.run_detailed(backtest_bars, Strategies.MA)\n```","ref":"backtesting.html#running-a-backtest"},{"type":"extras","title":"Creating Custom Strategies - IBKR Backtesting Framework","doc":"```elixir\ndefmodule MyStrategy do\n  use Backtester.Strategy\n\n  def init(opts) do\n    %{\n      short_window: Keyword.get(opts, :short_window, 5),\n      long_window: Keyword.get(opts, :long_window, 20)\n    }\n  end\n\n  def signal(current_bar, previous_bars, state) do\n    short_ma = calculate_ma(previous_bars, state.short_window)\n    long_ma = calculate_ma(previous_bars, state.long_window)\n    \n    cond do\n      short_ma > long_ma -> {:buy, state}\n      short_ma   {:sell, state}\n      true -> {:hold, state}\n    end\n  end\n\n  defp calculate_ma(bars, window) do\n    bars\n    |> Enum.take(window)\n    |> Enum.map(& &1.close)\n    |> Enum.sum()\n    |> Kernel./(window)\n  end\nend\n```","ref":"backtesting.html#creating-custom-strategies"},{"type":"extras","title":"API Reference - IBKR Backtesting Framework","doc":"","ref":"backtesting.html#api-reference"},{"type":"extras","title":"Backtester.Engine - IBKR Backtesting Framework","doc":"#### `run/3`\n\nRuns a basic backtest.\n\n**Parameters:**\n- `bars` - List of `Backtester.Bar` structs (chronologically ordered)\n- `strategy_module` - Module implementing `Backtester.Strategy`\n- `opts` - Options:\n  - `:starting_cash` - Initial portfolio value (default: 100,000.0)\n  - `:strategy_opts` - Options passed to strategy\n\n**Returns:**\n```elixir\n%{\n  portfolio: %Backtester.Portfolio{},\n  performance: %{\n    total_value: 105_250.0,\n    total_return: 5_250.0,\n    return_percent: 5.25,\n    realized_pnl: 2_100.0,\n    unrealized_pnl: 150.0,\n    total_trades: 8\n  },\n  trade_history: [...],\n  bars_processed: 100\n}\n```\n\n#### `run_detailed/3`\n\nRuns a detailed backtest with bar-by-bar portfolio tracking.\n\n**Additional Returns:**\n- `portfolio_values` - Array of portfolio values at each bar\n\n#### `calculate_metrics/1`\n\nCalculates extended performance metrics.\n\n**Additional Metrics:**\n- `win_rate` - Percentage of profitable trades\n- `sharpe_ratio` - Risk-adjusted return measure\n- `max_drawdown` - Maximum peak-to-trough decline\n- `volatility` - Standard deviation of returns","ref":"backtesting.html#backtester-engine"},{"type":"extras","title":"Backtester.Portfolio - IBKR Backtesting Framework","doc":"Portfolio management with buy/sell/hold operations.\n\n```elixir\n# Create new portfolio\nportfolio = Backtester.Portfolio.new(100_000.0)\n\n# Execute trades\nportfolio = Backtester.Portfolio.buy(portfolio, 150.0)\nportfolio = Backtester.Portfolio.sell(portfolio, 160.0)\n\n# Get performance stats\nstats = Backtester.Portfolio.performance_stats(portfolio, current_price)\n```","ref":"backtesting.html#backtester-portfolio"},{"type":"extras","title":"Backtester.Strategy - IBKR Backtesting Framework","doc":"Behavior for implementing trading strategies.\n\n**Required Callback:**\n```elixir\n@callback signal(\n  current_bar :: Backtester.Bar.t(),\n  previous_bars :: [Backtester.Bar.t()],\n  state :: map()\n) :: {:buy | :sell | :hold, map()}\n```\n\n**Optional Callback:**\n```elixir\n@callback init(opts :: keyword()) :: map()\n```","ref":"backtesting.html#backtester-strategy"},{"type":"extras","title":"Built-in Strategies - IBKR Backtesting Framework","doc":"","ref":"backtesting.html#built-in-strategies"},{"type":"extras","title":"Moving Average Strategy (`Backtester.Strategies.MA`) - IBKR Backtesting Framework","doc":"Simple moving average crossover strategy.\n\n**Options:**\n- `:window` - Moving average period (default: 5)\n\n**Logic:**\n- Buy when price > moving average\n- Sell when price < moving average\n- Hold when price equals moving average\n\n```elixir\n# Use with custom window\nEngine.run(bars, Backtester.Strategies.MA, \n  strategy_opts: [window: 20]\n)\n```","ref":"backtesting.html#moving-average-strategy-backtester-strategies-ma"},{"type":"extras","title":"Performance Metrics - IBKR Backtesting Framework","doc":"","ref":"backtesting.html#performance-metrics"},{"type":"extras","title":"Basic Metrics - IBKR Backtesting Framework","doc":"- **Total Return** - Absolute profit/loss\n- **Return Percentage** - Percentage gain/loss\n- **Realized P&L** - Profit from completed trades\n- **Unrealized P&L** - Profit from open positions","ref":"backtesting.html#basic-metrics"},{"type":"extras","title":"Advanced Metrics - IBKR Backtesting Framework","doc":"- **Win Rate** - Percentage of profitable trades\n- **Sharpe Ratio** - Risk-adjusted return (return/volatility)\n- **Maximum Drawdown** - Largest peak-to-trough decline\n- **Volatility** - Standard deviation of returns","ref":"backtesting.html#advanced-metrics"},{"type":"extras","title":"Examples - IBKR Backtesting Framework","doc":"","ref":"backtesting.html#examples"},{"type":"extras","title":"Compare Multiple Strategies - IBKR Backtesting Framework","doc":"```elixir\nstrategies = [\n  Backtester.Strategies.MA\n  # Add more strategies here\n]\n\n{:ok, comparison} = Backtester.Example.compare_strategies(\n  \"AAPL\", \"6mo\", \"1day\", strategies\n)\n\n# Print comparison results\nEnum.each(comparison.summary, fn strategy_result ->\n  IO.puts(\"#{strategy_result.strategy}: #{strategy_result.return_percent}%\")\nend)\n```","ref":"backtesting.html#compare-multiple-strategies"},{"type":"extras","title":"Custom Analysis - IBKR Backtesting Framework","doc":"```elixir\n# Run detailed backtest\n{:ok, result} = Backtester.Example.run_backtest(\"MSFT\", \"1y\", \"1day\")\n\n# Extract portfolio values for plotting\nportfolio_values = result.portfolio_values\ntimestamps = Enum.map(portfolio_values, & &1.timestamp)\nvalues = Enum.map(portfolio_values, & &1.portfolio_value)\n\n# Calculate custom metrics\nextended_metrics = Backtester.Engine.calculate_metrics(result)\nIO.inspect(extended_metrics)\n```","ref":"backtesting.html#custom-analysis"},{"type":"extras","title":"Integration with IBKR API - IBKR Backtesting Framework","doc":"The backtesting framework integrates seamlessly with the IBKR API:\n\n1. **Contract Search** - Use `IbkrApi.ClientPortal.Contract.search_contracts/2`\n2. **Historical Data** - Use `IbkrApi.ClientPortal.MarketData.get_historical_data/4`\n3. **Data Conversion** - Use `Backtester.Bar.from_historical_bar/1`","ref":"backtesting.html#integration-with-ibkr-api"},{"type":"extras","title":"Complete Workflow - IBKR Backtesting Framework","doc":"```elixir\n# 1. Search for contract\n{:ok, contracts} = IbkrApi.ClientPortal.Contract.search_contracts(\"AAPL\")\ncontract_id = List.first(contracts).conid\n\n# 2. Fetch historical data\n{:ok, historical_bars} = IbkrApi.ClientPortal.MarketData.get_historical_data(\n  to_string(contract_id), \"3mo\", \"1day\"\n)\n\n# 3. Convert to backtest format\nbacktest_bars = Enum.map(historical_bars, &Backtester.Bar.from_ibkr/1)\n\n# 4. Run backtest\nresult = Backtester.Engine.run_detailed(backtest_bars, Backtester.Strategies.MA)\n\n# 5. Analyze results\nBacktester.Example.print_report(Map.put(result, :symbol, \"AAPL\"))\n```","ref":"backtesting.html#complete-workflow"},{"type":"extras","title":"Best Practices - IBKR Backtesting Framework","doc":"1. **Data Quality** - Ensure historical data is clean and properly ordered\n2. **Strategy Validation** - Test strategies on multiple time periods and symbols\n3. **Risk Management** - Consider transaction costs and slippage in real trading\n4. **Overfitting** - Avoid over-optimizing strategies on historical data\n5. **Forward Testing** - Validate strategies on out-of-sample data","ref":"backtesting.html#best-practices"},{"type":"extras","title":"Limitations - IBKR Backtesting Framework","doc":"- **Simple Portfolio Model** - Currently supports single-asset, long-only strategies\n- **No Transaction Costs** - Backtests don't include commissions or slippage\n- **Perfect Execution** - Assumes all trades execute at exact bar close prices\n- **No Risk Management** - No built-in stop-loss or position sizing rules","ref":"backtesting.html#limitations"},{"type":"extras","title":"Future Enhancements - IBKR Backtesting Framework","doc":"- Multi-asset portfolio support\n- Short selling capabilities\n- Transaction cost modeling\n- Advanced order types\n- Risk management features\n- Performance attribution analysis","ref":"backtesting.html#future-enhancements"},{"type":"extras","title":"API Reference","doc":"# API Reference\n\nThis reference guide provides detailed information about all modules and functions available in the IbkrApi library.","ref":"api_reference.html"},{"type":"extras","title":"Core Modules - API Reference","doc":"","ref":"api_reference.html#core-modules"},{"type":"extras","title":"IbkrApi - API Reference","doc":"`IbkrApi` module that serves as the entry point to the library.","ref":"api_reference.html#ibkrapi"},{"type":"extras","title":"IbkrApi.Config - API Reference","doc":"`IbkrApi.Config` module for configuration management.\n\n```elixir\n# Get the base URL for API requests\nbase_url = IbkrApi.Config.base_url()\n```","ref":"api_reference.html#ibkrapi-config"},{"type":"extras","title":"IbkrApi.HTTP - API Reference","doc":"`IbkrApi.HTTP` module for rate-limited HTTP requests to the Interactive Brokers Client Portal API.\n\n```elixir\n# Make a GET request\n{:ok, response} = IbkrApi.HTTP.get(\"https://localhost:5000/v1/api/endpoint\")\n\n# Make a POST request with a body\nbody = %{key: \"value\"}\n{:ok, response} = IbkrApi.HTTP.post(\"https://localhost:5000/v1/api/endpoint\", body)\n\n# Make a PUT request\n{:ok, response} = IbkrApi.HTTP.put(\"https://localhost:5000/v1/api/endpoint\", body)\n\n# Make a DELETE request\n{:ok, response} = IbkrApi.HTTP.delete(\"https://localhost:5000/v1/api/endpoint\")\n```","ref":"api_reference.html#ibkrapi-http"},{"type":"extras","title":"IbkrApi.Websocket - API Reference","doc":"`IbkrApi.Websocket` module for real-time streaming data from the Interactive Brokers Client Portal API.\n\n```elixir\n# Create a WebSocket client module\ndefmodule MyIbkrClient do\n  use IbkrApi.Websocket\n\n  def handle_event({:market_data, data}, state) do\n    IO.inspect(data, label: \"Market Data\")\n    {:ok, state}\n  end\n\n  def handle_event({:order_update, order}, state) do\n    IO.inspect(order, label: \"Order Update\")\n    {:ok, state}\n  end\n\n  def handle_event({:pnl_update, pnl}, state) do\n    IO.inspect(pnl, label: \"P&L Update\")\n    {:ok, state}\n  end\n\n  def handle_event(_event, state) do\n    {:ok, state}\n  end\nend\n\n# Start the WebSocket client\n{:ok, pid} = MyIbkrClient.start_link(%{})\n\n# Subscribe to market data\nMyIbkrClient.subscribe_to_market_data(pid, [8314], [\"31\", \"83\"])\n\n# Subscribe to order updates\nMyIbkrClient.subscribe_to_order_updates(pid)\n\n# Subscribe to P&L updates\nMyIbkrClient.subscribe_to_pnl(pid)\n```\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|-------------|\n| `start_link/1` | Starts the WebSocket client | `state` (Map) | `{:ok, pid}` or `{:error, reason}` |\n| `subscribe_to_market_data/3` | Subscribes to real-time market data | `pid`, `conids` (List), `fields` (List) | `:ok` |\n| `subscribe_to_order_updates/1` | Subscribes to order status updates | `pid` | `:ok` |\n| `subscribe_to_pnl/1` | Subscribes to portfolio P&L updates | `pid` | `:ok` |\n| `unsubscribe_from_market_data/2` | Unsubscribes from market data | `pid`, `conids` (List) | `:ok` |\n| `unsubscribe_from_order_updates/1` | Unsubscribes from order updates | `pid` | `:ok` |\n| `unsubscribe_from_pnl/1` | Unsubscribes from P&L updates | `pid` | `:ok` |","ref":"api_reference.html#ibkrapi-websocket"},{"type":"extras","title":"Client Portal Modules - API Reference","doc":"","ref":"api_reference.html#client-portal-modules"},{"type":"extras","title":"IbkrApi.ClientPortal.Auth - API Reference","doc":"`IbkrApi.ClientPortal.Auth` module for authentication and session management.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|-------------|\n| `ping_server/0` | Checks server connectivity and authentication status | None | `{:ok, %PingServerResponse{}}` or `{:error, reason}` |\n| `reauthenticate/0` | Attempts to reauthenticate an expired session | None | `{:ok, %ReauthenticateResponse{}}` or `{:error, reason}` |\n| `end_session/0` | Ends the current session | None | `{:ok, %EndSessionResponse{}}` or `{:error, reason}` |\n| `validate_sso/0` | Validates Single Sign-On status | None | `{:ok, %ValidateSSOResponse{}}` or `{:error, reason}` |\n| `check_auth_status/0` | Checks the current authentication status | None | `{:ok, %CheckAuthStatusResponse{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-auth"},{"type":"extras","title":"IbkrApi.ClientPortal.Portfolio - API Reference","doc":"`IbkrApi.ClientPortal.Portfolio` module for managing account information, positions, and portfolio operations.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|-------------|\n| `list_accounts/0` | Lists all portfolio accounts | None | `{:ok, [%Account{}]}` or `{:error, reason}` |\n| `list_sub_accounts/0` | Lists all sub-accounts | None | `{:ok, [%SubAccount{}]}` or `{:error, reason}` |\n| `account_info/1` | Gets account metadata | `account_id` (String) | `{:ok, %Account{}}` or `{:error, reason}` |\n| `account_summary/1` | Gets account summary with dynamic fields | `account_id` (String) | `{:ok, %AccountSummary{}}` or `{:error, reason}` |\n| `account_ledger/1` | Gets account ledger by currency | `account_id` (String) | `{:ok, %AccountLedger{}}` or `{:error, reason}` |\n| `list_brokerage_accounts/0` | Lists all brokerage accounts | None | `{:ok, %BrokerageAccountsResponse{}}` or `{:error, reason}` |\n| `switch_account/1` | Switches the active account | `acct_id` (String) | `{:ok, %SwitchAccountResponse{}}` or `{:error, reason}` |\n| `get_pnl/0` | Gets profit and loss information | None | `{:ok, %PnLResponse{}}` or `{:error, reason}` |\n| `account_allocation/1` | Gets account allocation by group | `account_id` (String) | `{:ok, [%Allocation{}]}` or `{:error, reason}` |\n| `all_accounts_allocation/1` | Gets allocation for all accounts | `account_id` (String) | `{:ok, [%Allocation{}]}` or `{:error, reason}` |\n| `portfolio_positions/3` | Gets portfolio positions | `account_id`, `page_id`, `model` | `{:ok, [%Position{}]}` or `{:error, reason}` |\n| `position_by_conid/2` | Gets position by contract ID | `account_id`, `conid` | `{:ok, [%Position{}]}` or `{:error, reason}` |\n| `invalidate_positions_cache/1` | Invalidates the positions cache | `account_id` | `{:ok, %{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-portfolio"},{"type":"extras","title":"IbkrApi.ClientPortal.Contract - API Reference","doc":"`IbkrApi.ClientPortal.Contract` module for managing financial instruments and contracts.\n\n#### Functions\n\n| Function | Parameters | Description | Return |\n|----------|------------|-------------|--------|\n| `get_contract_info/2` | `conid`, `opts` | Get detailed contract information | `{:ok, [SecdefInfo.t()]}` |\n| `get_trading_schedule/3` | `asset_class`, `symbol`, `opts` | Get trading schedule for symbol | `{:ok, TradingSchedule.t()}` |\n| `security_stocks_by_symbol/1` | `symbol` | Get stock security definition | `{:ok, StockSecurityDefinition.t()}` |\n| `get_exchange_rate/2` | `source`, `target` | Get currency exchange rate | `{:ok, float()}` |\n| `get_available_currency_pairs/1` | `currency` | Get available currency pairs | `{:ok, [CurrencyPair.t()]}` |\n| `search_contracts/2` | `symbol`, `opts` | Search contracts by symbol | `{:ok, [SearchContract.t()]}` |\n| `get_strikes/4` | `contract_id`, `sec_type`, `month`, `opts` | Get option strikes for contract | `{:ok, StrikesResponse.t()}` |\n| `get_strikes/1` | `symbol` | Get strikes for symbol (convenience) | `{:ok, StrikesResponse.t()}` |\n| `contract_details/1` | `conid` | Get contract details | `{:ok, map()}` |\n| `get_stock_security_definition/1` | `symbol` | Get stock security definition | `{:ok, map()}` |\n| `get_options_for_symbol/2` | `symbol`, `opts` | Get options for symbol | `{:ok, map()}` |","ref":"api_reference.html#ibkrapi-clientportal-contract"},{"type":"extras","title":"IbkrApi.ClientPortal.MarketData - API Reference","doc":"Real-time and historical market data.\n\n| Function | Parameters | Description | Return |\n|----------|------------|-------------|--------|\n| `get_market_data_snapshot/2` | `conids`, `opts` | Get live market data snapshots | `{:ok, [MarketDataSnapshot.t()]}` |\n| `get_historical_data/4` | `conid`, `period`, `bar`, `opts` | Get historical market data | `{:ok, [HistoricalBar.t()]}` |\n\n**MarketDataSnapshot Fields:**\n- Price fields: `last_price`, `bid_price`, `ask_price`, `high`, `low`, `open`, `close`\n- Volume fields: `volume`, `bid_size`, `ask_size`, `last_size`, `average_volume`\n- Change fields: `change`, `change_percent`, `change_since_open`\n- P&L fields: `market_value`, `unrealized_pnl`, `daily_pnl`, `realized_pnl`\n- Greeks (options): `delta`, `gamma`, `theta`, `vega`\n- Company info: `company_name`, `symbol`, `industry`, `category`\n- Financial metrics: `market_cap`, `pe_ratio`, `eps`, `beta`","ref":"api_reference.html#ibkrapi-clientportal-marketdata"},{"type":"extras","title":"IbkrApi.ClientPortal.Order - API Reference","doc":"`IbkrApi.ClientPortal.Order` module for managing order placement and monitoring.\n\n#### Functions\n\n| Function | Parameters | Description | Return |\n|----------|------------|-------------|--------|\n| `get_live_orders/0` | - | Get all live orders | `{:ok, OrderResponse.t()}` |\n| `get_order_status/1` | `order_id` | Get order status | `{:ok, OrderStatusResponse.t()}` |\n| `place_orders/2` | `account_id`, `orders` | Place new orders | `{:ok, [OrderPlacementResponse.t()]}` |\n| `place_orders_for_fa/2` | `fa_group`, `orders` | Place orders for FA group | `{:ok, [OrderPlacementResponse.t()]}` |\n| `modify_order/3` | `account_id`, `order_id`, `request` | Modify existing order | `{:ok, ModifyOrderResponse.t()}` |\n| `cancel_order/2` | `account_id`, `order_id` | Cancel order | `{:ok, CancelOrderResponse.t()}` |\n| `preview_order/2` | `account_id`, `orders` | Preview order before placement | `{:ok, OrderPreviewResponse.t()}` |\n| `reply_to_order_query/2` | `reply_id`, `confirmed` | Reply to order confirmation query | `{:ok, OrderReplyResponse.t()}` |\n\n**Order Types Supported:**\n- Market orders (`MKT`)\n- Limit orders (`LMT`) \n- Stop orders (`STP`)\n- Stop-limit orders (`STP LMT`)\n- Trailing stop orders with amount or percentage\n- Adaptive orders for better execution","ref":"api_reference.html#ibkrapi-clientportal-order"},{"type":"extras","title":"IbkrApi.ClientPortal.Trade - API Reference","doc":"Trade execution history and details.\n\n| Function | Parameters | Description | Return |\n|----------|------------|-------------|--------|\n| `list_trades/0` | - | Get all trade executions | `{:ok, [Trade.t()]}` |\n\n**Trade Fields:**\n- Execution info: `execution_id`, `trade_time`, `size`, `price`\n- Order info: `order_description`, `order_ref`, `side`\n- Contract info: `symbol`, `conid`, `sec_type`, `company_name`\n- Financial info: `commission`, `net_amount`, `position`\n- Account info: `account`, `account_code`, `clearing_id`","ref":"api_reference.html#ibkrapi-clientportal-trade"},{"type":"extras","title":"IbkrApi.ClientPortal.Profile - API Reference","doc":"`IbkrApi.ClientPortal.Profile` module for managing user profile information.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `get_profile/0` | Gets user profile information | None | `{:ok, %Profile{}}` or `{:error, reason}` |\n| `update_profile/1` | Updates user profile | `profile_params` (Map) | `{:ok, %UpdateProfileResponse{}}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-profile"},{"type":"extras","title":"IbkrApi.ClientPortal.Trade - API Reference","doc":"`IbkrApi.ClientPortal.Trade` module for managing trade executions and history.\n\n#### Functions\n\n| Function | Description | Parameters | Return Value |\n|----------|-------------|------------|--------------|\n| `get_executions/1` | Gets trade executions for an account | `account_id` (String) | `{:ok, [%Execution{}]}` or `{:error, reason}` |","ref":"api_reference.html#ibkrapi-clientportal-trade"},{"type":"extras","title":"Error Handling - API Reference","doc":"All API functions return `{:ok, result}` on success and `{:error, reason}` on failure. The error reason is typically an `ErrorMessage` struct with the following fields:\n\n```elixir\n%ErrorMessage{\n  code: \"1234\",       # Error code\n  message: \"Error message description\",\n  description: \"Detailed error description\"\n}\n```","ref":"api_reference.html#error-handling"},{"type":"extras","title":"Common Error Codes - API Reference","doc":"| Code | Description |\n|------|-------------|\n| \"1015\" | Account not found or not authorized |\n| \"1021\" | Session expired, please reauthenticate |\n| \"1022\" | Invalid contract ID |\n| \"1100\" | Invalid order parameters |\n| \"1101\" | Insufficient funds |\n| \"2000\" | Server error |","ref":"api_reference.html#common-error-codes"},{"type":"extras","title":"Related Resources - API Reference","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Account Management](../how-to/account_management.html)\n- [Trading](../how-to/trading.html)\n- [Architecture](../explanations/architecture.html)","ref":"api_reference.html#related-resources"},{"type":"extras","title":"Architecture of IbkrApi","doc":"# Architecture of IbkrApi\n\nThis document explains the architecture and design principles of the IbkrApi library, providing context for developers who want to understand how the library works internally.\n\n> #### Architecture Overview {: .info}\n>\n> The IbkrApi library is designed to provide a **clean, idiomatic Elixir interface** to Interactive Brokers' Client Portal Web API. The library follows Elixir conventions and leverages the language's strengths in **concurrent programming** and **fault tolerance**.","ref":"architecture.html"},{"type":"extras","title":"Overview - Architecture of IbkrApi","doc":"IbkrApi is designed as a clean, idiomatic Elixir wrapper around Interactive Brokers' Client Portal API. The library follows these key design principles:\n\n1. **Simplicity**: Providing a straightforward interface to the IBKR API\n2. **Consistency**: Maintaining a consistent API design across all modules\n3. **Error Handling**: Comprehensive error handling with meaningful messages\n4. **Type Safety**: Using structs and typespecs for better code quality","ref":"architecture.html#overview"},{"type":"extras","title":"System Architecture - Architecture of IbkrApi","doc":"The IbkrApi library provides two distinct communication channels with the IBKR Client Portal Gateway:","ref":"architecture.html#system-architecture"},{"type":"extras","title":"Dual-Channel Architecture - Architecture of IbkrApi","doc":"```mermaid\nflowchart TD\n    Client[\"🏢 Client Code\"]\n    \n    %% REST API Channel\n    Client --> RestAPI[\"📡 REST API Calls\"]\n    RestAPI --> ClientPortal[\"IbkrApi.ClientPortal\"]\n    \n    ClientPortal --> Auth[\"🔐 Auth\"]\n    ClientPortal --> Portfolio[\"💼 Portfolio\"]\n    ClientPortal --> Order[\"📋 Order\"]\n    ClientPortal --> Contract[\"📄 Contract\"]\n    ClientPortal --> Trade[\"💱 Trade\"]\n    ClientPortal --> MarketData[\"📊 MarketData\"]\n    \n    Auth --> HTTP[\"IbkrApi.HTTP (Rate Limited)\"]\n    Portfolio --> HTTP\n    Order --> HTTP\n    Contract --> HTTP\n    Trade --> HTTP\n    MarketData --> HTTP\n    \n    HTTP --> SharedHTTP[\"IbkrApi.SharedUtils.HTTP\"]\n    SharedHTTP --> Finch[\"🌐 Finch (HTTP Client)\"]\n    \n    %% WebSocket Channel\n    Client --> RealTime[\"⚡ Real-time Data\"]\n    RealTime --> WebSocket[\"IbkrApi.Websocket\"]\n    WebSocket --> WebSockex[\"🔌 WebSockex (Behavior)\"]\n    \n    WebSocket --> WSMarketData[\"📈 Market Data\"]\n    WebSocket --> WSOrderUpdates[\"📋 Order Updates\"]\n    WebSocket --> WSPnL[\"💰 P&L Streaming\"]\n    \n    %% Gateway\n    Finch --> Gateway[\"🏛️ IBKR Client Portal Gateway\"]\n    WebSockex --> Gateway\n    \n    Gateway --> RestEndpoint[\"🌐 REST API (Port 5000)\"]\n    Gateway --> WSEndpoint[\"🔌 WebSocket API (wss://localhost:5000/v1/api/ws)\"]\n    \n    %% Styling\n    classDef clientCode fill:#e1f5fe\n    classDef restApi fill:#f3e5f5\n    classDef websocket fill:#e8f5e8\n    classDef http fill:#fff3e0\n    classDef gateway fill:#fce4ec\n    \n    class Client clientCode\n    class RestAPI,ClientPortal,Auth,Portfolio,Order,Contract,Trade,MarketData restApi\n    class RealTime,WebSocket,WebSockex,WSMarketData,WSOrderUpdates,WSPnL websocket\n    class HTTP,SharedHTTP,Finch http\n    class Gateway,RestEndpoint,WSEndpoint gateway\n```","ref":"architecture.html#dual-channel-architecture"},{"type":"extras","title":"Communication Channels - Architecture of IbkrApi","doc":"The library provides two independent communication channels:\n\n#### 1. REST API Channel (Request/Response)\n\n**Purpose**: Synchronous operations like authentication, account queries, order placement, and historical data retrieval.\n\n**Flow**: `ClientPortal Modules → IbkrApi.HTTP → SharedUtils.HTTP → Finch → IBKR Gateway REST API`\n\n**Key Modules**:\n- `IbkrApi.ClientPortal.Auth` - Authentication and session management\n- `IbkrApi.ClientPortal.Portfolio` - Account information, positions, P&L\n- `IbkrApi.ClientPortal.Order` - Order placement and management\n- `IbkrApi.ClientPortal.Contract` - Contract search and information\n- `IbkrApi.ClientPortal.MarketData` - Historical market data\n- `IbkrApi.ClientPortal.Trade` - Trade execution history\n\n**HTTP Stack**:\n- `IbkrApi.HTTP` - Rate-limited HTTP client wrapper\n- `IbkrApi.SharedUtils.HTTP` - Core HTTP functionality with Finch\n- `Finch` - Elixir HTTP client with connection pooling\n\n#### 2. WebSocket Channel (Real-time Streaming)\n\n**Purpose**: Real-time data streaming for market data, order updates, and portfolio P&L.\n\n**Flow**: `User Module → IbkrApi.Websocket → WebSockex → IBKR Gateway WebSocket API`\n\n**Key Features**:\n- `IbkrApi.Websocket` - WebSocket client using WebSockex behavior\n- Real-time market data streaming (Level I quotes)\n- Live order status updates and fills\n- Portfolio P&L streaming\n- Automatic heartbeat management\n- Topic-based event dispatch to user callbacks","ref":"architecture.html#communication-channels"},{"type":"extras","title":"Core Components - Architecture of IbkrApi","doc":"1. **IbkrApi**: The main module that serves as the entry point to the library\n2. **IbkrApi.Application**: Manages the application lifecycle and dependencies\n3. **IbkrApi.Config**: Handles configuration for the library\n4. **IbkrApi.HTTP**: Low-level HTTP client for making requests to the API","ref":"architecture.html#core-components"},{"type":"extras","title":"Domain-Specific Modules - Architecture of IbkrApi","doc":"The `IbkrApi.ClientPortal` namespace contains domain-specific modules that correspond to different areas of the IBKR API:\n\n1. **IbkrApi.ClientPortal.Auth**: Authentication and session management\n2. **IbkrApi.ClientPortal.Account**: Account information and operations\n3. **IbkrApi.ClientPortal.Contract**: Financial instruments and contracts\n4. **IbkrApi.ClientPortal.Order**: Order placement and monitoring\n5. **IbkrApi.ClientPortal.Profile**: User profile information\n6. **IbkrApi.ClientPortal.Trade**: Trade executions and history","ref":"architecture.html#domain-specific-modules"},{"type":"extras","title":"Data Flow - Architecture of IbkrApi","doc":"A typical request through the library follows this flow:\n\n1. Client code calls a function in one of the domain-specific modules\n2. The domain module constructs the appropriate request parameters\n3. The request is passed to `IbkrApi.HTTP` which handles the HTTP communication\n4. `IbkrApi.HTTP` uses Finch to make the actual HTTP request to the IBKR Gateway\n5. The response is received and parsed (typically from JSON to Elixir structs)\n6. The domain module returns the structured response to the client code","ref":"architecture.html#data-flow"},{"type":"extras","title":"Error Handling - Architecture of IbkrApi","doc":"The library uses the `ErrorMessage` module for consistent error handling:\n\n```elixir\ndefmodule ErrorMessage do\n  @type t :: %__MODULE__{\n    code: String.t() | nil,\n    message: String.t() | nil,\n    description: String.t() | nil\n  }\n  \n  @type t_res :: {:ok, any()} | {:error, t()}\n  \n  defstruct [:code, :message, :description]\nend\n```\n\nAll API functions return either `{:ok, result}` on success or `{:error, %ErrorMessage{}}` on failure, allowing for consistent error handling throughout the application.","ref":"architecture.html#error-handling"},{"type":"extras","title":"Data Structures - Architecture of IbkrApi","doc":"The library uses Elixir structs to represent API responses. Each domain module defines its own set of structs that match the structure of the API responses. For example:\n\n```elixir\ndefmodule IbkrApi.ClientPortal.Auth.CheckAuthStatusResponse do\n  defstruct authenticated: nil, competing: nil, connected: nil,\n            fail: nil, hardware_info: nil, mac: nil, message: nil,\n            server_info: %IbkrApi.ClientPortal.Auth.ServerInfo{}\nend\n```\n\nThis approach provides type safety and makes it clear what data is available from each API call.","ref":"architecture.html#data-structures"},{"type":"extras","title":"Configuration - Architecture of IbkrApi","doc":"The library is configured through the standard Elixir configuration system:\n\n```elixir\nconfig :ibkr_api,\n  base_url: \"http://localhost:5000/v1/api\",\n  timeout: 30_000\n```\n\nThe `IbkrApi.Config` module provides functions to access this configuration:\n\n```elixir\ndefmodule IbkrApi.Config do\n  def base_url, do: Application.get_env(:ibkr_api, :base_url, \"http://localhost:5000/v1/api\")\n  def timeout, do: Application.get_env(:ibkr_api, :timeout, 30_000)\nend\n```","ref":"architecture.html#configuration"},{"type":"extras","title":"HTTP Client - Architecture of IbkrApi","doc":"The `IbkrApi.HTTP` module handles all HTTP communication with the IBKR API. It uses Finch for making HTTP requests and Jason for JSON encoding/decoding:\n\n```elixir\ndefmodule IbkrApi.HTTP do\n  @spec get(String.t()) :: ErrorMessage.t_res()\n  def get(url) do\n    # Implementation...\n  end\n\n  @spec post(String.t(), map()) :: ErrorMessage.t_res()\n  def post(url, body) do\n    # Implementation...\n  end\nend\n```","ref":"architecture.html#http-client"},{"type":"extras","title":"Design Decisions - Architecture of IbkrApi","doc":"","ref":"architecture.html#design-decisions"},{"type":"extras","title":"Why Finch? - Architecture of IbkrApi","doc":"Finch was chosen as the HTTP client because:\n- It's a modern, fast HTTP client for Elixir\n- It provides connection pooling for better performance\n- It's well-maintained and widely used in the Elixir community","ref":"architecture.html#why-finch"},{"type":"extras","title":"Why Structs for API Responses? - Architecture of IbkrApi","doc":"Structs were chosen to represent API responses because:\n- They provide a clear structure for the data\n- They enable type checking with dialyzer\n- They make it clear what data is available from each API call\n- They allow for pattern matching in client code","ref":"architecture.html#why-structs-for-api-responses"},{"type":"extras","title":"Why the ClientPortal Namespace? - Architecture of IbkrApi","doc":"The `IbkrApi.ClientPortal` namespace was created to:\n- Separate the Client Portal API from potential future APIs\n- Group related functionality together\n- Allow for easy discovery of available modules","ref":"architecture.html#why-the-clientportal-namespace"},{"type":"extras","title":"Testing Strategy - Architecture of IbkrApi","doc":"The library is designed to be testable at multiple levels:\n\n1. **Unit Tests**: Test individual functions in isolation\n2. **Integration Tests**: Test interaction between modules\n3. **API Tests**: Test actual communication with the IBKR API (requires a running gateway)\n\nMock modules can be used to simulate API responses for testing without a live connection to the IBKR gateway.","ref":"architecture.html#testing-strategy"},{"type":"extras","title":"WebSocket Architecture - Architecture of IbkrApi","doc":"The library includes a comprehensive WebSocket implementation for real-time data streaming:","ref":"architecture.html#websocket-architecture"},{"type":"extras","title":"IbkrApi.Websocket Module - Architecture of IbkrApi","doc":"The WebSocket implementation uses the WebSockex behavior and provides:\n\n- **Connection Management**: Automatic SSL configuration for localhost connections\n- **Message Parsing**: Handles IBKR's ` + + ` message format\n- **Event Dispatch**: Topic-based routing to user-defined `handle_event/2` callbacks\n- **Heartbeat Management**: Automatic heartbeat messages every 10 seconds\n- **Subscription Management**: Helper functions for market data, orders, and P&L","ref":"architecture.html#ibkrapi-websocket-module"},{"type":"extras","title":"WebSocket Message Flow - Architecture of IbkrApi","doc":"```\nIBKR Gateway ──WebSocket──> IbkrApi.Websocket ──Events──> User Module\n     │                            │                         │\n     │                            │                         │\n     └──── Heartbeat ←────────────┴─── Subscriptions ←──────┘\n```","ref":"architecture.html#websocket-message-flow"},{"type":"extras","title":"Supported Data Streams - Architecture of IbkrApi","doc":"1. **Market Data (`smd`)**: Level I top-of-book data with configurable fields\n2. **Order Updates (`sor`)**: Real-time order status changes and fills\n3. **P&L Updates (`spl`)**: Portfolio profit/loss streaming\n4. **System Messages**: Connection status and system notifications","ref":"architecture.html#supported-data-streams"},{"type":"extras","title":"Usage Pattern - Architecture of IbkrApi","doc":"Users implement the `__using__` macro to create WebSocket clients:\n\n```elixir\ndefmodule MyTradingBot do\n  use IbkrApi.Websocket\n\n  def handle_event({:market_data, data}, state) do\n    # Process market data\n    {:ok, state}\n  end\nend\n```","ref":"architecture.html#usage-pattern"},{"type":"extras","title":"Future Considerations - Architecture of IbkrApi","doc":"Potential future enhancements to the architecture include:\n\n1. **Rate Limiting**: Implementing intelligent rate limiting to avoid API throttling\n2. **Caching**: Adding a caching layer for frequently accessed data\n3. **Retry Logic**: Implementing automatic retries for transient failures\n4. **Async Operations**: Supporting asynchronous operations for long-running requests\n5. **Enhanced WebSocket Features**: Multi-account streaming, advanced reconnection strategies","ref":"architecture.html#future-considerations"},{"type":"extras","title":"Related Resources - Architecture of IbkrApi","doc":"- [Getting Started](../tutorials/getting_started.html)\n- [Authentication](../tutorials/authentication.html)\n- [Account Management](../how-to/account_management.html)\n- [Trading](../how-to/trading.html)\n- [API Reference](../reference/api_reference.html)","ref":"architecture.html#related-resources"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}